<?php

namespace AcumaticaConfig\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Sanity ServiceType
 * @subpackage Services
 */
class Sanity extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SanityCheck
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AcumaticaConfig\StructType\SanityCheck $parameters
     * @return \AcumaticaConfig\StructType\SanityCheckResponse|bool
     */
    public function SanityCheck(\AcumaticaConfig\StructType\SanityCheck $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SanityCheck($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \AcumaticaConfig\StructType\SanityCheckResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
