<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicationsCreditMemo StructType
 * @subpackage Structs
 */
class ApplicationsCreditMemo extends AbstractStructBase
{
    /**
     * The InvoiceApplicationsCreditMemo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo[]
     */
    public $InvoiceApplicationsCreditMemo;
    /**
     * Constructor method for ApplicationsCreditMemo
     * @uses ApplicationsCreditMemo::setInvoiceApplicationsCreditMemo()
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo[] $invoiceApplicationsCreditMemo
     */
    public function __construct(array $invoiceApplicationsCreditMemo = array())
    {
        $this
            ->setInvoiceApplicationsCreditMemo($invoiceApplicationsCreditMemo);
    }
    /**
     * Get InvoiceApplicationsCreditMemo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo[]|null
     */
    public function getInvoiceApplicationsCreditMemo()
    {
        return isset($this->InvoiceApplicationsCreditMemo) ? $this->InvoiceApplicationsCreditMemo : null;
    }
    /**
     * Set InvoiceApplicationsCreditMemo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo[] $invoiceApplicationsCreditMemo
     * @return \AcumaticaConfig\StructType\ApplicationsCreditMemo
     */
    public function setInvoiceApplicationsCreditMemo(array $invoiceApplicationsCreditMemo = array())
    {
        foreach ($invoiceApplicationsCreditMemo as $applicationsCreditMemoInvoiceApplicationsCreditMemoItem) {
            // validation for constraint: itemType
            if (!$applicationsCreditMemoInvoiceApplicationsCreditMemoItem instanceof \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo) {
                throw new \InvalidArgumentException(sprintf('The InvoiceApplicationsCreditMemo property can only contain items of \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo, "%s" given', is_object($applicationsCreditMemoInvoiceApplicationsCreditMemoItem) ? get_class($applicationsCreditMemoInvoiceApplicationsCreditMemoItem) : gettype($applicationsCreditMemoInvoiceApplicationsCreditMemoItem)), __LINE__);
            }
        }
        if (is_null($invoiceApplicationsCreditMemo) || (is_array($invoiceApplicationsCreditMemo) && empty($invoiceApplicationsCreditMemo))) {
            unset($this->InvoiceApplicationsCreditMemo);
        } else {
            $this->InvoiceApplicationsCreditMemo = $invoiceApplicationsCreditMemo;
        }
        return $this;
    }
    /**
     * Add item to InvoiceApplicationsCreditMemo value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo $item
     * @return \AcumaticaConfig\StructType\ApplicationsCreditMemo
     */
    public function addToInvoiceApplicationsCreditMemo(\AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo) {
            throw new \InvalidArgumentException(sprintf('The InvoiceApplicationsCreditMemo property can only contain items of \AcumaticaConfig\StructType\InvoiceApplicationsCreditMemo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InvoiceApplicationsCreditMemo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ApplicationsCreditMemo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
