<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicationsDefault StructType
 * @subpackage Structs
 */
class ApplicationsDefault extends AbstractStructBase
{
    /**
     * The InvoiceApplicationsDefault
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\InvoiceApplicationsDefault[]
     */
    public $InvoiceApplicationsDefault;
    /**
     * Constructor method for ApplicationsDefault
     * @uses ApplicationsDefault::setInvoiceApplicationsDefault()
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsDefault[] $invoiceApplicationsDefault
     */
    public function __construct(array $invoiceApplicationsDefault = array())
    {
        $this
            ->setInvoiceApplicationsDefault($invoiceApplicationsDefault);
    }
    /**
     * Get InvoiceApplicationsDefault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\InvoiceApplicationsDefault[]|null
     */
    public function getInvoiceApplicationsDefault()
    {
        return isset($this->InvoiceApplicationsDefault) ? $this->InvoiceApplicationsDefault : null;
    }
    /**
     * Set InvoiceApplicationsDefault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsDefault[] $invoiceApplicationsDefault
     * @return \AcumaticaConfig\StructType\ApplicationsDefault
     */
    public function setInvoiceApplicationsDefault(array $invoiceApplicationsDefault = array())
    {
        foreach ($invoiceApplicationsDefault as $applicationsDefaultInvoiceApplicationsDefaultItem) {
            // validation for constraint: itemType
            if (!$applicationsDefaultInvoiceApplicationsDefaultItem instanceof \AcumaticaConfig\StructType\InvoiceApplicationsDefault) {
                throw new \InvalidArgumentException(sprintf('The InvoiceApplicationsDefault property can only contain items of \AcumaticaConfig\StructType\InvoiceApplicationsDefault, "%s" given', is_object($applicationsDefaultInvoiceApplicationsDefaultItem) ? get_class($applicationsDefaultInvoiceApplicationsDefaultItem) : gettype($applicationsDefaultInvoiceApplicationsDefaultItem)), __LINE__);
            }
        }
        if (is_null($invoiceApplicationsDefault) || (is_array($invoiceApplicationsDefault) && empty($invoiceApplicationsDefault))) {
            unset($this->InvoiceApplicationsDefault);
        } else {
            $this->InvoiceApplicationsDefault = $invoiceApplicationsDefault;
        }
        return $this;
    }
    /**
     * Add item to InvoiceApplicationsDefault value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\InvoiceApplicationsDefault $item
     * @return \AcumaticaConfig\StructType\ApplicationsDefault
     */
    public function addToInvoiceApplicationsDefault(\AcumaticaConfig\StructType\InvoiceApplicationsDefault $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\InvoiceApplicationsDefault) {
            throw new \InvalidArgumentException(sprintf('The InvoiceApplicationsDefault property can only contain items of \AcumaticaConfig\StructType\InvoiceApplicationsDefault, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InvoiceApplicationsDefault[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ApplicationsDefault
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
