<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttributesDetail StructType
 * @subpackage Structs
 */
class AttributesDetail extends Entity
{
    /**
     * The AttributeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $AttributeID;
    /**
     * The ControlType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $ControlType;
    /**
     * The DefaultValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $DefaultValue;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The EntityClassID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $EntityClassID;
    /**
     * The Internal
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $Internal;
    /**
     * The Required
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $Required;
    /**
     * The SortOrder
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ShortValue
     */
    public $SortOrder;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Type;
    /**
     * The AttributesDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\AttributesDetail[]
     */
    public $AttributesDetail;
    /**
     * Constructor method for AttributesDetail
     * @uses AttributesDetail::setAttributeID()
     * @uses AttributesDetail::setControlType()
     * @uses AttributesDetail::setDefaultValue()
     * @uses AttributesDetail::setDescription()
     * @uses AttributesDetail::setEntityClassID()
     * @uses AttributesDetail::setInternal()
     * @uses AttributesDetail::setRequired()
     * @uses AttributesDetail::setSortOrder()
     * @uses AttributesDetail::setType()
     * @uses AttributesDetail::setAttributesDetail()
     * @param \AcumaticaConfig\StructType\StringValue $attributeID
     * @param \AcumaticaConfig\StructType\StringValue $controlType
     * @param \AcumaticaConfig\StructType\StringValue $defaultValue
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\StringValue $entityClassID
     * @param \AcumaticaConfig\StructType\BooleanValue $internal
     * @param \AcumaticaConfig\StructType\BooleanValue $required
     * @param \AcumaticaConfig\StructType\ShortValue $sortOrder
     * @param \AcumaticaConfig\StructType\StringValue $type
     * @param \AcumaticaConfig\StructType\AttributesDetail[] $attributesDetail
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $attributeID = null, \AcumaticaConfig\StructType\StringValue $controlType = null, \AcumaticaConfig\StructType\StringValue $defaultValue = null, \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\StringValue $entityClassID = null, \AcumaticaConfig\StructType\BooleanValue $internal = null, \AcumaticaConfig\StructType\BooleanValue $required = null, \AcumaticaConfig\StructType\ShortValue $sortOrder = null, \AcumaticaConfig\StructType\StringValue $type = null, array $attributesDetail = array())
    {
        $this
            ->setAttributeID($attributeID)
            ->setControlType($controlType)
            ->setDefaultValue($defaultValue)
            ->setDescription($description)
            ->setEntityClassID($entityClassID)
            ->setInternal($internal)
            ->setRequired($required)
            ->setSortOrder($sortOrder)
            ->setType($type)
            ->setAttributesDetail($attributesDetail);
    }
    /**
     * Get AttributeID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getAttributeID()
    {
        return isset($this->AttributeID) ? $this->AttributeID : null;
    }
    /**
     * Set AttributeID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $attributeID
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setAttributeID(\AcumaticaConfig\StructType\StringValue $attributeID = null)
    {
        if (is_null($attributeID) || (is_array($attributeID) && empty($attributeID))) {
            unset($this->AttributeID);
        } else {
            $this->AttributeID = $attributeID;
        }
        return $this;
    }
    /**
     * Get ControlType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getControlType()
    {
        return isset($this->ControlType) ? $this->ControlType : null;
    }
    /**
     * Set ControlType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $controlType
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setControlType(\AcumaticaConfig\StructType\StringValue $controlType = null)
    {
        if (is_null($controlType) || (is_array($controlType) && empty($controlType))) {
            unset($this->ControlType);
        } else {
            $this->ControlType = $controlType;
        }
        return $this;
    }
    /**
     * Get DefaultValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDefaultValue()
    {
        return isset($this->DefaultValue) ? $this->DefaultValue : null;
    }
    /**
     * Set DefaultValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $defaultValue
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setDefaultValue(\AcumaticaConfig\StructType\StringValue $defaultValue = null)
    {
        if (is_null($defaultValue) || (is_array($defaultValue) && empty($defaultValue))) {
            unset($this->DefaultValue);
        } else {
            $this->DefaultValue = $defaultValue;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get EntityClassID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getEntityClassID()
    {
        return isset($this->EntityClassID) ? $this->EntityClassID : null;
    }
    /**
     * Set EntityClassID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $entityClassID
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setEntityClassID(\AcumaticaConfig\StructType\StringValue $entityClassID = null)
    {
        if (is_null($entityClassID) || (is_array($entityClassID) && empty($entityClassID))) {
            unset($this->EntityClassID);
        } else {
            $this->EntityClassID = $entityClassID;
        }
        return $this;
    }
    /**
     * Get Internal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getInternal()
    {
        return isset($this->Internal) ? $this->Internal : null;
    }
    /**
     * Set Internal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $internal
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setInternal(\AcumaticaConfig\StructType\BooleanValue $internal = null)
    {
        if (is_null($internal) || (is_array($internal) && empty($internal))) {
            unset($this->Internal);
        } else {
            $this->Internal = $internal;
        }
        return $this;
    }
    /**
     * Get Required value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getRequired()
    {
        return isset($this->Required) ? $this->Required : null;
    }
    /**
     * Set Required value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $required
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setRequired(\AcumaticaConfig\StructType\BooleanValue $required = null)
    {
        if (is_null($required) || (is_array($required) && empty($required))) {
            unset($this->Required);
        } else {
            $this->Required = $required;
        }
        return $this;
    }
    /**
     * Get SortOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ShortValue|null
     */
    public function getSortOrder()
    {
        return isset($this->SortOrder) ? $this->SortOrder : null;
    }
    /**
     * Set SortOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\ShortValue $sortOrder
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setSortOrder(\AcumaticaConfig\StructType\ShortValue $sortOrder = null)
    {
        if (is_null($sortOrder) || (is_array($sortOrder) && empty($sortOrder))) {
            unset($this->SortOrder);
        } else {
            $this->SortOrder = $sortOrder;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $type
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setType(\AcumaticaConfig\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Get AttributesDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\AttributesDetail[]|null
     */
    public function getAttributesDetail()
    {
        return isset($this->AttributesDetail) ? $this->AttributesDetail : null;
    }
    /**
     * Set AttributesDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\AttributesDetail[] $attributesDetail
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function setAttributesDetail(array $attributesDetail = array())
    {
        foreach ($attributesDetail as $attributesDetailAttributesDetailItem) {
            // validation for constraint: itemType
            if (!$attributesDetailAttributesDetailItem instanceof \AcumaticaConfig\StructType\AttributesDetail) {
                throw new \InvalidArgumentException(sprintf('The AttributesDetail property can only contain items of \AcumaticaConfig\StructType\AttributesDetail, "%s" given', is_object($attributesDetailAttributesDetailItem) ? get_class($attributesDetailAttributesDetailItem) : gettype($attributesDetailAttributesDetailItem)), __LINE__);
            }
        }
        if (is_null($attributesDetail) || (is_array($attributesDetail) && empty($attributesDetail))) {
            unset($this->AttributesDetail);
        } else {
            $this->AttributesDetail = $attributesDetail;
        }
        return $this;
    }
    /**
     * Add item to AttributesDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\AttributesDetail $item
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public function addToAttributesDetail(\AcumaticaConfig\StructType\AttributesDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\AttributesDetail) {
            throw new \InvalidArgumentException(sprintf('The AttributesDetail property can only contain items of \AcumaticaConfig\StructType\AttributesDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AttributesDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\AttributesDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
