<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Boxes StructType
 * @subpackage Structs
 */
class Boxes extends AbstractStructBase
{
    /**
     * The BoxStockItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BoxStockItem[]
     */
    public $BoxStockItem;
    /**
     * Constructor method for Boxes
     * @uses Boxes::setBoxStockItem()
     * @param \AcumaticaConfig\StructType\BoxStockItem[] $boxStockItem
     */
    public function __construct(array $boxStockItem = array())
    {
        $this
            ->setBoxStockItem($boxStockItem);
    }
    /**
     * Get BoxStockItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BoxStockItem[]|null
     */
    public function getBoxStockItem()
    {
        return isset($this->BoxStockItem) ? $this->BoxStockItem : null;
    }
    /**
     * Set BoxStockItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\BoxStockItem[] $boxStockItem
     * @return \AcumaticaConfig\StructType\Boxes
     */
    public function setBoxStockItem(array $boxStockItem = array())
    {
        foreach ($boxStockItem as $boxesBoxStockItemItem) {
            // validation for constraint: itemType
            if (!$boxesBoxStockItemItem instanceof \AcumaticaConfig\StructType\BoxStockItem) {
                throw new \InvalidArgumentException(sprintf('The BoxStockItem property can only contain items of \AcumaticaConfig\StructType\BoxStockItem, "%s" given', is_object($boxesBoxStockItemItem) ? get_class($boxesBoxStockItemItem) : gettype($boxesBoxStockItemItem)), __LINE__);
            }
        }
        if (is_null($boxStockItem) || (is_array($boxStockItem) && empty($boxStockItem))) {
            unset($this->BoxStockItem);
        } else {
            $this->BoxStockItem = $boxStockItem;
        }
        return $this;
    }
    /**
     * Add item to BoxStockItem value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\BoxStockItem $item
     * @return \AcumaticaConfig\StructType\Boxes
     */
    public function addToBoxStockItem(\AcumaticaConfig\StructType\BoxStockItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\BoxStockItem) {
            throw new \InvalidArgumentException(sprintf('The BoxStockItem property can only contain items of \AcumaticaConfig\StructType\BoxStockItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BoxStockItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\Boxes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
