<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CategoryImageResults StructType
 * @subpackage Structs
 */
class CategoryImageResults extends Entity
{
    /**
     * The CategoryImageResults
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\CategoryImageResults[]
     */
    public $CategoryImageResults;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Name;
    /**
     * The NoteDoc_fileID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\GuidValue
     */
    public $NoteDoc_fileID;
    /**
     * Constructor method for CategoryImageResults
     * @uses CategoryImageResults::setCategoryImageResults()
     * @uses CategoryImageResults::setDescription()
     * @uses CategoryImageResults::setName()
     * @uses CategoryImageResults::setNoteDoc_fileID()
     * @param \AcumaticaConfig\StructType\CategoryImageResults[] $categoryImageResults
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\StringValue $name
     * @param \AcumaticaConfig\StructType\GuidValue $noteDoc_fileID
     */
    public function __construct(array $categoryImageResults = array(), \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\StringValue $name = null, \AcumaticaConfig\StructType\GuidValue $noteDoc_fileID = null)
    {
        $this
            ->setCategoryImageResults($categoryImageResults)
            ->setDescription($description)
            ->setName($name)
            ->setNoteDoc_fileID($noteDoc_fileID);
    }
    /**
     * Get CategoryImageResults value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\CategoryImageResults[]|null
     */
    public function getCategoryImageResults()
    {
        return isset($this->CategoryImageResults) ? $this->CategoryImageResults : null;
    }
    /**
     * Set CategoryImageResults value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CategoryImageResults[] $categoryImageResults
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public function setCategoryImageResults(array $categoryImageResults = array())
    {
        foreach ($categoryImageResults as $categoryImageResultsCategoryImageResultsItem) {
            // validation for constraint: itemType
            if (!$categoryImageResultsCategoryImageResultsItem instanceof \AcumaticaConfig\StructType\CategoryImageResults) {
                throw new \InvalidArgumentException(sprintf('The CategoryImageResults property can only contain items of \AcumaticaConfig\StructType\CategoryImageResults, "%s" given', is_object($categoryImageResultsCategoryImageResultsItem) ? get_class($categoryImageResultsCategoryImageResultsItem) : gettype($categoryImageResultsCategoryImageResultsItem)), __LINE__);
            }
        }
        if (is_null($categoryImageResults) || (is_array($categoryImageResults) && empty($categoryImageResults))) {
            unset($this->CategoryImageResults);
        } else {
            $this->CategoryImageResults = $categoryImageResults;
        }
        return $this;
    }
    /**
     * Add item to CategoryImageResults value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CategoryImageResults $item
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public function addToCategoryImageResults(\AcumaticaConfig\StructType\CategoryImageResults $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\CategoryImageResults) {
            throw new \InvalidArgumentException(sprintf('The CategoryImageResults property can only contain items of \AcumaticaConfig\StructType\CategoryImageResults, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CategoryImageResults[] = $item;
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $name
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public function setName(\AcumaticaConfig\StructType\StringValue $name = null)
    {
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get NoteDoc_fileID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\GuidValue|null
     */
    public function getNoteDoc_fileID()
    {
        return isset($this->NoteDoc_fileID) ? $this->NoteDoc_fileID : null;
    }
    /**
     * Set NoteDoc_fileID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\GuidValue $noteDoc_fileID
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public function setNoteDoc_fileID(\AcumaticaConfig\StructType\GuidValue $noteDoc_fileID = null)
    {
        if (is_null($noteDoc_fileID) || (is_array($noteDoc_fileID) && empty($noteDoc_fileID))) {
            unset($this->NoteDoc_fileID);
        } else {
            $this->NoteDoc_fileID = $noteDoc_fileID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\CategoryImageResults
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
