<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Commissions StructType
 * @subpackage Structs
 */
class Commissions extends Entity
{
    /**
     * The DefaultSalesperson
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $DefaultSalesperson;
    /**
     * The SalesPersons
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\SalesPersons_1
     */
    public $SalesPersons;
    /**
     * Constructor method for Commissions
     * @uses Commissions::setDefaultSalesperson()
     * @uses Commissions::setSalesPersons()
     * @param \AcumaticaConfig\StructType\StringValue $defaultSalesperson
     * @param \AcumaticaConfig\StructType\SalesPersons_1 $salesPersons
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $defaultSalesperson = null, \AcumaticaConfig\StructType\SalesPersons_1 $salesPersons = null)
    {
        $this
            ->setDefaultSalesperson($defaultSalesperson)
            ->setSalesPersons($salesPersons);
    }
    /**
     * Get DefaultSalesperson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDefaultSalesperson()
    {
        return isset($this->DefaultSalesperson) ? $this->DefaultSalesperson : null;
    }
    /**
     * Set DefaultSalesperson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $defaultSalesperson
     * @return \AcumaticaConfig\StructType\Commissions
     */
    public function setDefaultSalesperson(\AcumaticaConfig\StructType\StringValue $defaultSalesperson = null)
    {
        if (is_null($defaultSalesperson) || (is_array($defaultSalesperson) && empty($defaultSalesperson))) {
            unset($this->DefaultSalesperson);
        } else {
            $this->DefaultSalesperson = $defaultSalesperson;
        }
        return $this;
    }
    /**
     * Get SalesPersons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\SalesPersons_1|null
     */
    public function getSalesPersons()
    {
        return isset($this->SalesPersons) ? $this->SalesPersons : null;
    }
    /**
     * Set SalesPersons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\SalesPersons_1 $salesPersons
     * @return \AcumaticaConfig\StructType\Commissions
     */
    public function setSalesPersons(\AcumaticaConfig\StructType\SalesPersons_1 $salesPersons = null)
    {
        if (is_null($salesPersons) || (is_array($salesPersons) && empty($salesPersons))) {
            unset($this->SalesPersons);
        } else {
            $this->SalesPersons = $salesPersons;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\Commissions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
