<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactRoles StructType
 * @subpackage Structs
 */
class ContactRoles extends Entity
{
    /**
     * The RoleDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $RoleDescription;
    /**
     * The RoleName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $RoleName;
    /**
     * The Selected
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $Selected;
    /**
     * The UserType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $UserType;
    /**
     * Constructor method for ContactRoles
     * @uses ContactRoles::setRoleDescription()
     * @uses ContactRoles::setRoleName()
     * @uses ContactRoles::setSelected()
     * @uses ContactRoles::setUserType()
     * @param \AcumaticaConfig\StructType\StringValue $roleDescription
     * @param \AcumaticaConfig\StructType\StringValue $roleName
     * @param \AcumaticaConfig\StructType\BooleanValue $selected
     * @param \AcumaticaConfig\StructType\IntValue $userType
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $roleDescription = null, \AcumaticaConfig\StructType\StringValue $roleName = null, \AcumaticaConfig\StructType\BooleanValue $selected = null, \AcumaticaConfig\StructType\IntValue $userType = null)
    {
        $this
            ->setRoleDescription($roleDescription)
            ->setRoleName($roleName)
            ->setSelected($selected)
            ->setUserType($userType);
    }
    /**
     * Get RoleDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getRoleDescription()
    {
        return isset($this->RoleDescription) ? $this->RoleDescription : null;
    }
    /**
     * Set RoleDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $roleDescription
     * @return \AcumaticaConfig\StructType\ContactRoles
     */
    public function setRoleDescription(\AcumaticaConfig\StructType\StringValue $roleDescription = null)
    {
        if (is_null($roleDescription) || (is_array($roleDescription) && empty($roleDescription))) {
            unset($this->RoleDescription);
        } else {
            $this->RoleDescription = $roleDescription;
        }
        return $this;
    }
    /**
     * Get RoleName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getRoleName()
    {
        return isset($this->RoleName) ? $this->RoleName : null;
    }
    /**
     * Set RoleName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $roleName
     * @return \AcumaticaConfig\StructType\ContactRoles
     */
    public function setRoleName(\AcumaticaConfig\StructType\StringValue $roleName = null)
    {
        if (is_null($roleName) || (is_array($roleName) && empty($roleName))) {
            unset($this->RoleName);
        } else {
            $this->RoleName = $roleName;
        }
        return $this;
    }
    /**
     * Get Selected value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getSelected()
    {
        return isset($this->Selected) ? $this->Selected : null;
    }
    /**
     * Set Selected value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $selected
     * @return \AcumaticaConfig\StructType\ContactRoles
     */
    public function setSelected(\AcumaticaConfig\StructType\BooleanValue $selected = null)
    {
        if (is_null($selected) || (is_array($selected) && empty($selected))) {
            unset($this->Selected);
        } else {
            $this->Selected = $selected;
        }
        return $this;
    }
    /**
     * Get UserType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getUserType()
    {
        return isset($this->UserType) ? $this->UserType : null;
    }
    /**
     * Set UserType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $userType
     * @return \AcumaticaConfig\StructType\ContactRoles
     */
    public function setUserType(\AcumaticaConfig\StructType\IntValue $userType = null)
    {
        if (is_null($userType) || (is_array($userType) && empty($userType))) {
            unset($this->UserType);
        } else {
            $this->UserType = $userType;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ContactRoles
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
