<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateOpportunitySalesOrder StructType
 * @subpackage Structs
 */
class CreateOpportunitySalesOrder extends Action
{
    /**
     * The OrderType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $OrderType;
    /**
     * The RecalculatePricesandDiscounts
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $RecalculatePricesandDiscounts;
    /**
     * Constructor method for CreateOpportunitySalesOrder
     * @uses CreateOpportunitySalesOrder::setOrderType()
     * @uses CreateOpportunitySalesOrder::setRecalculatePricesandDiscounts()
     * @param \AcumaticaConfig\StructType\StringValue $orderType
     * @param \AcumaticaConfig\StructType\BooleanValue $recalculatePricesandDiscounts
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $orderType = null, \AcumaticaConfig\StructType\BooleanValue $recalculatePricesandDiscounts = null)
    {
        $this
            ->setOrderType($orderType)
            ->setRecalculatePricesandDiscounts($recalculatePricesandDiscounts);
    }
    /**
     * Get OrderType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getOrderType()
    {
        return isset($this->OrderType) ? $this->OrderType : null;
    }
    /**
     * Set OrderType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $orderType
     * @return \AcumaticaConfig\StructType\CreateOpportunitySalesOrder
     */
    public function setOrderType(\AcumaticaConfig\StructType\StringValue $orderType = null)
    {
        if (is_null($orderType) || (is_array($orderType) && empty($orderType))) {
            unset($this->OrderType);
        } else {
            $this->OrderType = $orderType;
        }
        return $this;
    }
    /**
     * Get RecalculatePricesandDiscounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getRecalculatePricesandDiscounts()
    {
        return isset($this->RecalculatePricesandDiscounts) ? $this->RecalculatePricesandDiscounts : null;
    }
    /**
     * Set RecalculatePricesandDiscounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $recalculatePricesandDiscounts
     * @return \AcumaticaConfig\StructType\CreateOpportunitySalesOrder
     */
    public function setRecalculatePricesandDiscounts(\AcumaticaConfig\StructType\BooleanValue $recalculatePricesandDiscounts = null)
    {
        if (is_null($recalculatePricesandDiscounts) || (is_array($recalculatePricesandDiscounts) && empty($recalculatePricesandDiscounts))) {
            unset($this->RecalculatePricesandDiscounts);
        } else {
            $this->RecalculatePricesandDiscounts = $recalculatePricesandDiscounts;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\CreateOpportunitySalesOrder
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
