<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditCardProcessingDetail StructType
 * @subpackage Structs
 */
class CreditCardProcessingDetail extends Entity
{
    /**
     * The TransactionAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $TransactionAmount;
    /**
     * The TransactionStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $TransactionStatus;
    /**
     * Constructor method for CreditCardProcessingDetail
     * @uses CreditCardProcessingDetail::setTransactionAmount()
     * @uses CreditCardProcessingDetail::setTransactionStatus()
     * @param \AcumaticaConfig\StructType\DecimalValue $transactionAmount
     * @param \AcumaticaConfig\StructType\StringValue $transactionStatus
     */
    public function __construct(\AcumaticaConfig\StructType\DecimalValue $transactionAmount = null, \AcumaticaConfig\StructType\StringValue $transactionStatus = null)
    {
        $this
            ->setTransactionAmount($transactionAmount)
            ->setTransactionStatus($transactionStatus);
    }
    /**
     * Get TransactionAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getTransactionAmount()
    {
        return isset($this->TransactionAmount) ? $this->TransactionAmount : null;
    }
    /**
     * Set TransactionAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $transactionAmount
     * @return \AcumaticaConfig\StructType\CreditCardProcessingDetail
     */
    public function setTransactionAmount(\AcumaticaConfig\StructType\DecimalValue $transactionAmount = null)
    {
        if (is_null($transactionAmount) || (is_array($transactionAmount) && empty($transactionAmount))) {
            unset($this->TransactionAmount);
        } else {
            $this->TransactionAmount = $transactionAmount;
        }
        return $this;
    }
    /**
     * Get TransactionStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTransactionStatus()
    {
        return isset($this->TransactionStatus) ? $this->TransactionStatus : null;
    }
    /**
     * Set TransactionStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $transactionStatus
     * @return \AcumaticaConfig\StructType\CreditCardProcessingDetail
     */
    public function setTransactionStatus(\AcumaticaConfig\StructType\StringValue $transactionStatus = null)
    {
        if (is_null($transactionStatus) || (is_array($transactionStatus) && empty($transactionStatus))) {
            unset($this->TransactionStatus);
        } else {
            $this->TransactionStatus = $transactionStatus;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\CreditCardProcessingDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
