<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerPriceClasses StructType
 * @subpackage Structs
 */
class CustomerPriceClasses extends AbstractStructBase
{
    /**
     * The DiscountCustomerPriceClassesDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail[]
     */
    public $DiscountCustomerPriceClassesDetail;
    /**
     * Constructor method for CustomerPriceClasses
     * @uses CustomerPriceClasses::setDiscountCustomerPriceClassesDetail()
     * @param \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail[] $discountCustomerPriceClassesDetail
     */
    public function __construct(array $discountCustomerPriceClassesDetail = array())
    {
        $this
            ->setDiscountCustomerPriceClassesDetail($discountCustomerPriceClassesDetail);
    }
    /**
     * Get DiscountCustomerPriceClassesDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail[]|null
     */
    public function getDiscountCustomerPriceClassesDetail()
    {
        return isset($this->DiscountCustomerPriceClassesDetail) ? $this->DiscountCustomerPriceClassesDetail : null;
    }
    /**
     * Set DiscountCustomerPriceClassesDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail[] $discountCustomerPriceClassesDetail
     * @return \AcumaticaConfig\StructType\CustomerPriceClasses
     */
    public function setDiscountCustomerPriceClassesDetail(array $discountCustomerPriceClassesDetail = array())
    {
        foreach ($discountCustomerPriceClassesDetail as $customerPriceClassesDiscountCustomerPriceClassesDetailItem) {
            // validation for constraint: itemType
            if (!$customerPriceClassesDiscountCustomerPriceClassesDetailItem instanceof \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail) {
                throw new \InvalidArgumentException(sprintf('The DiscountCustomerPriceClassesDetail property can only contain items of \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail, "%s" given', is_object($customerPriceClassesDiscountCustomerPriceClassesDetailItem) ? get_class($customerPriceClassesDiscountCustomerPriceClassesDetailItem) : gettype($customerPriceClassesDiscountCustomerPriceClassesDetailItem)), __LINE__);
            }
        }
        if (is_null($discountCustomerPriceClassesDetail) || (is_array($discountCustomerPriceClassesDetail) && empty($discountCustomerPriceClassesDetail))) {
            unset($this->DiscountCustomerPriceClassesDetail);
        } else {
            $this->DiscountCustomerPriceClassesDetail = $discountCustomerPriceClassesDetail;
        }
        return $this;
    }
    /**
     * Add item to DiscountCustomerPriceClassesDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail $item
     * @return \AcumaticaConfig\StructType\CustomerPriceClasses
     */
    public function addToDiscountCustomerPriceClassesDetail(\AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail) {
            throw new \InvalidArgumentException(sprintf('The DiscountCustomerPriceClassesDetail property can only contain items of \AcumaticaConfig\StructType\DiscountCustomerPriceClassesDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DiscountCustomerPriceClassesDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\CustomerPriceClasses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
