<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersDeletedResults StructType
 * @subpackage Structs
 */
class CustomersDeletedResults extends Entity
{
    /**
     * The CustomersDeletedResults
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\CustomersDeletedResults[]
     */
    public $CustomersDeletedResults;
    /**
     * The Acctcd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Acctcd;
    /**
     * The AcctName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $AcctName;
    /**
     * Constructor method for CustomersDeletedResults
     * @uses CustomersDeletedResults::setCustomersDeletedResults()
     * @uses CustomersDeletedResults::setAcctcd()
     * @uses CustomersDeletedResults::setAcctName()
     * @param \AcumaticaConfig\StructType\CustomersDeletedResults[] $customersDeletedResults
     * @param \AcumaticaConfig\StructType\StringValue $acctcd
     * @param \AcumaticaConfig\StructType\StringValue $acctName
     */
    public function __construct(array $customersDeletedResults = array(), \AcumaticaConfig\StructType\StringValue $acctcd = null, \AcumaticaConfig\StructType\StringValue $acctName = null)
    {
        $this
            ->setCustomersDeletedResults($customersDeletedResults)
            ->setAcctcd($acctcd)
            ->setAcctName($acctName);
    }
    /**
     * Get CustomersDeletedResults value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults[]|null
     */
    public function getCustomersDeletedResults()
    {
        return isset($this->CustomersDeletedResults) ? $this->CustomersDeletedResults : null;
    }
    /**
     * Set CustomersDeletedResults value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CustomersDeletedResults[] $customersDeletedResults
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults
     */
    public function setCustomersDeletedResults(array $customersDeletedResults = array())
    {
        foreach ($customersDeletedResults as $customersDeletedResultsCustomersDeletedResultsItem) {
            // validation for constraint: itemType
            if (!$customersDeletedResultsCustomersDeletedResultsItem instanceof \AcumaticaConfig\StructType\CustomersDeletedResults) {
                throw new \InvalidArgumentException(sprintf('The CustomersDeletedResults property can only contain items of \AcumaticaConfig\StructType\CustomersDeletedResults, "%s" given', is_object($customersDeletedResultsCustomersDeletedResultsItem) ? get_class($customersDeletedResultsCustomersDeletedResultsItem) : gettype($customersDeletedResultsCustomersDeletedResultsItem)), __LINE__);
            }
        }
        if (is_null($customersDeletedResults) || (is_array($customersDeletedResults) && empty($customersDeletedResults))) {
            unset($this->CustomersDeletedResults);
        } else {
            $this->CustomersDeletedResults = $customersDeletedResults;
        }
        return $this;
    }
    /**
     * Add item to CustomersDeletedResults value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CustomersDeletedResults $item
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults
     */
    public function addToCustomersDeletedResults(\AcumaticaConfig\StructType\CustomersDeletedResults $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\CustomersDeletedResults) {
            throw new \InvalidArgumentException(sprintf('The CustomersDeletedResults property can only contain items of \AcumaticaConfig\StructType\CustomersDeletedResults, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CustomersDeletedResults[] = $item;
        return $this;
    }
    /**
     * Get Acctcd value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getAcctcd()
    {
        return isset($this->Acctcd) ? $this->Acctcd : null;
    }
    /**
     * Set Acctcd value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $acctcd
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults
     */
    public function setAcctcd(\AcumaticaConfig\StructType\StringValue $acctcd = null)
    {
        if (is_null($acctcd) || (is_array($acctcd) && empty($acctcd))) {
            unset($this->Acctcd);
        } else {
            $this->Acctcd = $acctcd;
        }
        return $this;
    }
    /**
     * Get AcctName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getAcctName()
    {
        return isset($this->AcctName) ? $this->AcctName : null;
    }
    /**
     * Set AcctName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $acctName
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults
     */
    public function setAcctName(\AcumaticaConfig\StructType\StringValue $acctName = null)
    {
        if (is_null($acctName) || (is_array($acctName) && empty($acctName))) {
            unset($this->AcctName);
        } else {
            $this->AcctName = $acctName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\CustomersDeletedResults
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
