<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DiscountBreakpoints StructType
 * @subpackage Structs
 */
class DiscountBreakpoints extends AbstractStructBase
{
    /**
     * The DiscountBreakpointDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DiscountBreakpointDetail[]
     */
    public $DiscountBreakpointDetail;
    /**
     * Constructor method for DiscountBreakpoints
     * @uses DiscountBreakpoints::setDiscountBreakpointDetail()
     * @param \AcumaticaConfig\StructType\DiscountBreakpointDetail[] $discountBreakpointDetail
     */
    public function __construct(array $discountBreakpointDetail = array())
    {
        $this
            ->setDiscountBreakpointDetail($discountBreakpointDetail);
    }
    /**
     * Get DiscountBreakpointDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DiscountBreakpointDetail[]|null
     */
    public function getDiscountBreakpointDetail()
    {
        return isset($this->DiscountBreakpointDetail) ? $this->DiscountBreakpointDetail : null;
    }
    /**
     * Set DiscountBreakpointDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\DiscountBreakpointDetail[] $discountBreakpointDetail
     * @return \AcumaticaConfig\StructType\DiscountBreakpoints
     */
    public function setDiscountBreakpointDetail(array $discountBreakpointDetail = array())
    {
        foreach ($discountBreakpointDetail as $discountBreakpointsDiscountBreakpointDetailItem) {
            // validation for constraint: itemType
            if (!$discountBreakpointsDiscountBreakpointDetailItem instanceof \AcumaticaConfig\StructType\DiscountBreakpointDetail) {
                throw new \InvalidArgumentException(sprintf('The DiscountBreakpointDetail property can only contain items of \AcumaticaConfig\StructType\DiscountBreakpointDetail, "%s" given', is_object($discountBreakpointsDiscountBreakpointDetailItem) ? get_class($discountBreakpointsDiscountBreakpointDetailItem) : gettype($discountBreakpointsDiscountBreakpointDetailItem)), __LINE__);
            }
        }
        if (is_null($discountBreakpointDetail) || (is_array($discountBreakpointDetail) && empty($discountBreakpointDetail))) {
            unset($this->DiscountBreakpointDetail);
        } else {
            $this->DiscountBreakpointDetail = $discountBreakpointDetail;
        }
        return $this;
    }
    /**
     * Add item to DiscountBreakpointDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\DiscountBreakpointDetail $item
     * @return \AcumaticaConfig\StructType\DiscountBreakpoints
     */
    public function addToDiscountBreakpointDetail(\AcumaticaConfig\StructType\DiscountBreakpointDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\DiscountBreakpointDetail) {
            throw new \InvalidArgumentException(sprintf('The DiscountBreakpointDetail property can only contain items of \AcumaticaConfig\StructType\DiscountBreakpointDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DiscountBreakpointDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\DiscountBreakpoints
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
