<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DuplicateDetail StructType
 * @subpackage Structs
 */
class DuplicateDetail extends Entity
{
    /**
     * The AccountName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $AccountName;
    /**
     * The BusinessAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $BusinessAccount;
    /**
     * The BusinessAccountType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $BusinessAccountType;
    /**
     * The ContactID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $ContactID;
    /**
     * The DisplayName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $DisplayName;
    /**
     * The Duplicate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Duplicate;
    /**
     * The DuplicateContactID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $DuplicateContactID;
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Email;
    /**
     * The EntityType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $EntityType;
    /**
     * The LastModifiedDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $LastModifiedDate;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Type;
    /**
     * Constructor method for DuplicateDetail
     * @uses DuplicateDetail::setAccountName()
     * @uses DuplicateDetail::setBusinessAccount()
     * @uses DuplicateDetail::setBusinessAccountType()
     * @uses DuplicateDetail::setContactID()
     * @uses DuplicateDetail::setDisplayName()
     * @uses DuplicateDetail::setDuplicate()
     * @uses DuplicateDetail::setDuplicateContactID()
     * @uses DuplicateDetail::setEmail()
     * @uses DuplicateDetail::setEntityType()
     * @uses DuplicateDetail::setLastModifiedDate()
     * @uses DuplicateDetail::setType()
     * @param \AcumaticaConfig\StructType\StringValue $accountName
     * @param \AcumaticaConfig\StructType\StringValue $businessAccount
     * @param \AcumaticaConfig\StructType\StringValue $businessAccountType
     * @param \AcumaticaConfig\StructType\IntValue $contactID
     * @param \AcumaticaConfig\StructType\StringValue $displayName
     * @param \AcumaticaConfig\StructType\StringValue $duplicate
     * @param \AcumaticaConfig\StructType\IntValue $duplicateContactID
     * @param \AcumaticaConfig\StructType\StringValue $email
     * @param \AcumaticaConfig\StructType\StringValue $entityType
     * @param \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDate
     * @param \AcumaticaConfig\StructType\StringValue $type
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $accountName = null, \AcumaticaConfig\StructType\StringValue $businessAccount = null, \AcumaticaConfig\StructType\StringValue $businessAccountType = null, \AcumaticaConfig\StructType\IntValue $contactID = null, \AcumaticaConfig\StructType\StringValue $displayName = null, \AcumaticaConfig\StructType\StringValue $duplicate = null, \AcumaticaConfig\StructType\IntValue $duplicateContactID = null, \AcumaticaConfig\StructType\StringValue $email = null, \AcumaticaConfig\StructType\StringValue $entityType = null, \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDate = null, \AcumaticaConfig\StructType\StringValue $type = null)
    {
        $this
            ->setAccountName($accountName)
            ->setBusinessAccount($businessAccount)
            ->setBusinessAccountType($businessAccountType)
            ->setContactID($contactID)
            ->setDisplayName($displayName)
            ->setDuplicate($duplicate)
            ->setDuplicateContactID($duplicateContactID)
            ->setEmail($email)
            ->setEntityType($entityType)
            ->setLastModifiedDate($lastModifiedDate)
            ->setType($type);
    }
    /**
     * Get AccountName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getAccountName()
    {
        return isset($this->AccountName) ? $this->AccountName : null;
    }
    /**
     * Set AccountName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $accountName
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setAccountName(\AcumaticaConfig\StructType\StringValue $accountName = null)
    {
        if (is_null($accountName) || (is_array($accountName) && empty($accountName))) {
            unset($this->AccountName);
        } else {
            $this->AccountName = $accountName;
        }
        return $this;
    }
    /**
     * Get BusinessAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getBusinessAccount()
    {
        return isset($this->BusinessAccount) ? $this->BusinessAccount : null;
    }
    /**
     * Set BusinessAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $businessAccount
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setBusinessAccount(\AcumaticaConfig\StructType\StringValue $businessAccount = null)
    {
        if (is_null($businessAccount) || (is_array($businessAccount) && empty($businessAccount))) {
            unset($this->BusinessAccount);
        } else {
            $this->BusinessAccount = $businessAccount;
        }
        return $this;
    }
    /**
     * Get BusinessAccountType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getBusinessAccountType()
    {
        return isset($this->BusinessAccountType) ? $this->BusinessAccountType : null;
    }
    /**
     * Set BusinessAccountType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $businessAccountType
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setBusinessAccountType(\AcumaticaConfig\StructType\StringValue $businessAccountType = null)
    {
        if (is_null($businessAccountType) || (is_array($businessAccountType) && empty($businessAccountType))) {
            unset($this->BusinessAccountType);
        } else {
            $this->BusinessAccountType = $businessAccountType;
        }
        return $this;
    }
    /**
     * Get ContactID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getContactID()
    {
        return isset($this->ContactID) ? $this->ContactID : null;
    }
    /**
     * Set ContactID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $contactID
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setContactID(\AcumaticaConfig\StructType\IntValue $contactID = null)
    {
        if (is_null($contactID) || (is_array($contactID) && empty($contactID))) {
            unset($this->ContactID);
        } else {
            $this->ContactID = $contactID;
        }
        return $this;
    }
    /**
     * Get DisplayName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDisplayName()
    {
        return isset($this->DisplayName) ? $this->DisplayName : null;
    }
    /**
     * Set DisplayName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $displayName
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setDisplayName(\AcumaticaConfig\StructType\StringValue $displayName = null)
    {
        if (is_null($displayName) || (is_array($displayName) && empty($displayName))) {
            unset($this->DisplayName);
        } else {
            $this->DisplayName = $displayName;
        }
        return $this;
    }
    /**
     * Get Duplicate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDuplicate()
    {
        return isset($this->Duplicate) ? $this->Duplicate : null;
    }
    /**
     * Set Duplicate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $duplicate
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setDuplicate(\AcumaticaConfig\StructType\StringValue $duplicate = null)
    {
        if (is_null($duplicate) || (is_array($duplicate) && empty($duplicate))) {
            unset($this->Duplicate);
        } else {
            $this->Duplicate = $duplicate;
        }
        return $this;
    }
    /**
     * Get DuplicateContactID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getDuplicateContactID()
    {
        return isset($this->DuplicateContactID) ? $this->DuplicateContactID : null;
    }
    /**
     * Set DuplicateContactID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $duplicateContactID
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setDuplicateContactID(\AcumaticaConfig\StructType\IntValue $duplicateContactID = null)
    {
        if (is_null($duplicateContactID) || (is_array($duplicateContactID) && empty($duplicateContactID))) {
            unset($this->DuplicateContactID);
        } else {
            $this->DuplicateContactID = $duplicateContactID;
        }
        return $this;
    }
    /**
     * Get Email value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getEmail()
    {
        return isset($this->Email) ? $this->Email : null;
    }
    /**
     * Set Email value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $email
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setEmail(\AcumaticaConfig\StructType\StringValue $email = null)
    {
        if (is_null($email) || (is_array($email) && empty($email))) {
            unset($this->Email);
        } else {
            $this->Email = $email;
        }
        return $this;
    }
    /**
     * Get EntityType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getEntityType()
    {
        return isset($this->EntityType) ? $this->EntityType : null;
    }
    /**
     * Set EntityType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $entityType
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setEntityType(\AcumaticaConfig\StructType\StringValue $entityType = null)
    {
        if (is_null($entityType) || (is_array($entityType) && empty($entityType))) {
            unset($this->EntityType);
        } else {
            $this->EntityType = $entityType;
        }
        return $this;
    }
    /**
     * Get LastModifiedDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getLastModifiedDate()
    {
        return isset($this->LastModifiedDate) ? $this->LastModifiedDate : null;
    }
    /**
     * Set LastModifiedDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDate
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setLastModifiedDate(\AcumaticaConfig\StructType\DateTimeValue $lastModifiedDate = null)
    {
        if (is_null($lastModifiedDate) || (is_array($lastModifiedDate) && empty($lastModifiedDate))) {
            unset($this->LastModifiedDate);
        } else {
            $this->LastModifiedDate = $lastModifiedDate;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $type
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public function setType(\AcumaticaConfig\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\DuplicateDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
