<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmailProcessingRow StructType
 * @subpackage Structs
 */
class EmailProcessingRow extends Entity
{
    /**
     * The EmailAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $EmailAccount;
    /**
     * The From
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $From;
    /**
     * The MailStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $MailStatus;
    /**
     * The Owner
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Owner;
    /**
     * The Selected
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $Selected;
    /**
     * The StartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $StartDate;
    /**
     * The Subject
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Subject;
    /**
     * The To
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $To;
    /**
     * Constructor method for EmailProcessingRow
     * @uses EmailProcessingRow::setEmailAccount()
     * @uses EmailProcessingRow::setFrom()
     * @uses EmailProcessingRow::setMailStatus()
     * @uses EmailProcessingRow::setOwner()
     * @uses EmailProcessingRow::setSelected()
     * @uses EmailProcessingRow::setStartDate()
     * @uses EmailProcessingRow::setSubject()
     * @uses EmailProcessingRow::setTo()
     * @param \AcumaticaConfig\StructType\StringValue $emailAccount
     * @param \AcumaticaConfig\StructType\StringValue $from
     * @param \AcumaticaConfig\StructType\StringValue $mailStatus
     * @param \AcumaticaConfig\StructType\StringValue $owner
     * @param \AcumaticaConfig\StructType\BooleanValue $selected
     * @param \AcumaticaConfig\StructType\DateTimeValue $startDate
     * @param \AcumaticaConfig\StructType\StringValue $subject
     * @param \AcumaticaConfig\StructType\StringValue $to
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $emailAccount = null, \AcumaticaConfig\StructType\StringValue $from = null, \AcumaticaConfig\StructType\StringValue $mailStatus = null, \AcumaticaConfig\StructType\StringValue $owner = null, \AcumaticaConfig\StructType\BooleanValue $selected = null, \AcumaticaConfig\StructType\DateTimeValue $startDate = null, \AcumaticaConfig\StructType\StringValue $subject = null, \AcumaticaConfig\StructType\StringValue $to = null)
    {
        $this
            ->setEmailAccount($emailAccount)
            ->setFrom($from)
            ->setMailStatus($mailStatus)
            ->setOwner($owner)
            ->setSelected($selected)
            ->setStartDate($startDate)
            ->setSubject($subject)
            ->setTo($to);
    }
    /**
     * Get EmailAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getEmailAccount()
    {
        return isset($this->EmailAccount) ? $this->EmailAccount : null;
    }
    /**
     * Set EmailAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $emailAccount
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setEmailAccount(\AcumaticaConfig\StructType\StringValue $emailAccount = null)
    {
        if (is_null($emailAccount) || (is_array($emailAccount) && empty($emailAccount))) {
            unset($this->EmailAccount);
        } else {
            $this->EmailAccount = $emailAccount;
        }
        return $this;
    }
    /**
     * Get From value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getFrom()
    {
        return isset($this->From) ? $this->From : null;
    }
    /**
     * Set From value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $from
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setFrom(\AcumaticaConfig\StructType\StringValue $from = null)
    {
        if (is_null($from) || (is_array($from) && empty($from))) {
            unset($this->From);
        } else {
            $this->From = $from;
        }
        return $this;
    }
    /**
     * Get MailStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getMailStatus()
    {
        return isset($this->MailStatus) ? $this->MailStatus : null;
    }
    /**
     * Set MailStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $mailStatus
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setMailStatus(\AcumaticaConfig\StructType\StringValue $mailStatus = null)
    {
        if (is_null($mailStatus) || (is_array($mailStatus) && empty($mailStatus))) {
            unset($this->MailStatus);
        } else {
            $this->MailStatus = $mailStatus;
        }
        return $this;
    }
    /**
     * Get Owner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getOwner()
    {
        return isset($this->Owner) ? $this->Owner : null;
    }
    /**
     * Set Owner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $owner
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setOwner(\AcumaticaConfig\StructType\StringValue $owner = null)
    {
        if (is_null($owner) || (is_array($owner) && empty($owner))) {
            unset($this->Owner);
        } else {
            $this->Owner = $owner;
        }
        return $this;
    }
    /**
     * Get Selected value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getSelected()
    {
        return isset($this->Selected) ? $this->Selected : null;
    }
    /**
     * Set Selected value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $selected
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setSelected(\AcumaticaConfig\StructType\BooleanValue $selected = null)
    {
        if (is_null($selected) || (is_array($selected) && empty($selected))) {
            unset($this->Selected);
        } else {
            $this->Selected = $selected;
        }
        return $this;
    }
    /**
     * Get StartDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getStartDate()
    {
        return isset($this->StartDate) ? $this->StartDate : null;
    }
    /**
     * Set StartDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $startDate
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setStartDate(\AcumaticaConfig\StructType\DateTimeValue $startDate = null)
    {
        if (is_null($startDate) || (is_array($startDate) && empty($startDate))) {
            unset($this->StartDate);
        } else {
            $this->StartDate = $startDate;
        }
        return $this;
    }
    /**
     * Get Subject value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getSubject()
    {
        return isset($this->Subject) ? $this->Subject : null;
    }
    /**
     * Set Subject value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $subject
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setSubject(\AcumaticaConfig\StructType\StringValue $subject = null)
    {
        if (is_null($subject) || (is_array($subject) && empty($subject))) {
            unset($this->Subject);
        } else {
            $this->Subject = $subject;
        }
        return $this;
    }
    /**
     * Get To value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTo()
    {
        return isset($this->To) ? $this->To : null;
    }
    /**
     * Set To value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $to
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public function setTo(\AcumaticaConfig\StructType\StringValue $to = null)
    {
        if (is_null($to) || (is_array($to) && empty($to))) {
            unset($this->To);
        } else {
            $this->To = $to;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\EmailProcessingRow
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
