<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeCost StructType
 * @subpackage Structs
 */
class EmployeeCost extends AbstractStructBase
{
    /**
     * The EmployeeCostRecord
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\EmployeeCostRecord[]
     */
    public $EmployeeCostRecord;
    /**
     * Constructor method for EmployeeCost
     * @uses EmployeeCost::setEmployeeCostRecord()
     * @param \AcumaticaConfig\StructType\EmployeeCostRecord[] $employeeCostRecord
     */
    public function __construct(array $employeeCostRecord = array())
    {
        $this
            ->setEmployeeCostRecord($employeeCostRecord);
    }
    /**
     * Get EmployeeCostRecord value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\EmployeeCostRecord[]|null
     */
    public function getEmployeeCostRecord()
    {
        return isset($this->EmployeeCostRecord) ? $this->EmployeeCostRecord : null;
    }
    /**
     * Set EmployeeCostRecord value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\EmployeeCostRecord[] $employeeCostRecord
     * @return \AcumaticaConfig\StructType\EmployeeCost
     */
    public function setEmployeeCostRecord(array $employeeCostRecord = array())
    {
        foreach ($employeeCostRecord as $employeeCostEmployeeCostRecordItem) {
            // validation for constraint: itemType
            if (!$employeeCostEmployeeCostRecordItem instanceof \AcumaticaConfig\StructType\EmployeeCostRecord) {
                throw new \InvalidArgumentException(sprintf('The EmployeeCostRecord property can only contain items of \AcumaticaConfig\StructType\EmployeeCostRecord, "%s" given', is_object($employeeCostEmployeeCostRecordItem) ? get_class($employeeCostEmployeeCostRecordItem) : gettype($employeeCostEmployeeCostRecordItem)), __LINE__);
            }
        }
        if (is_null($employeeCostRecord) || (is_array($employeeCostRecord) && empty($employeeCostRecord))) {
            unset($this->EmployeeCostRecord);
        } else {
            $this->EmployeeCostRecord = $employeeCostRecord;
        }
        return $this;
    }
    /**
     * Add item to EmployeeCostRecord value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\EmployeeCostRecord $item
     * @return \AcumaticaConfig\StructType\EmployeeCost
     */
    public function addToEmployeeCostRecord(\AcumaticaConfig\StructType\EmployeeCostRecord $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\EmployeeCostRecord) {
            throw new \InvalidArgumentException(sprintf('The EmployeeCostRecord property can only contain items of \AcumaticaConfig\StructType\EmployeeCostRecord, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EmployeeCostRecord[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\EmployeeCost
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
