<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmploymentHistory StructType
 * @subpackage Structs
 */
class EmploymentHistory extends AbstractStructBase
{
    /**
     * The EmploymentHistoryRecord
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\EmploymentHistoryRecord[]
     */
    public $EmploymentHistoryRecord;
    /**
     * Constructor method for EmploymentHistory
     * @uses EmploymentHistory::setEmploymentHistoryRecord()
     * @param \AcumaticaConfig\StructType\EmploymentHistoryRecord[] $employmentHistoryRecord
     */
    public function __construct(array $employmentHistoryRecord = array())
    {
        $this
            ->setEmploymentHistoryRecord($employmentHistoryRecord);
    }
    /**
     * Get EmploymentHistoryRecord value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\EmploymentHistoryRecord[]|null
     */
    public function getEmploymentHistoryRecord()
    {
        return isset($this->EmploymentHistoryRecord) ? $this->EmploymentHistoryRecord : null;
    }
    /**
     * Set EmploymentHistoryRecord value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\EmploymentHistoryRecord[] $employmentHistoryRecord
     * @return \AcumaticaConfig\StructType\EmploymentHistory
     */
    public function setEmploymentHistoryRecord(array $employmentHistoryRecord = array())
    {
        foreach ($employmentHistoryRecord as $employmentHistoryEmploymentHistoryRecordItem) {
            // validation for constraint: itemType
            if (!$employmentHistoryEmploymentHistoryRecordItem instanceof \AcumaticaConfig\StructType\EmploymentHistoryRecord) {
                throw new \InvalidArgumentException(sprintf('The EmploymentHistoryRecord property can only contain items of \AcumaticaConfig\StructType\EmploymentHistoryRecord, "%s" given', is_object($employmentHistoryEmploymentHistoryRecordItem) ? get_class($employmentHistoryEmploymentHistoryRecordItem) : gettype($employmentHistoryEmploymentHistoryRecordItem)), __LINE__);
            }
        }
        if (is_null($employmentHistoryRecord) || (is_array($employmentHistoryRecord) && empty($employmentHistoryRecord))) {
            unset($this->EmploymentHistoryRecord);
        } else {
            $this->EmploymentHistoryRecord = $employmentHistoryRecord;
        }
        return $this;
    }
    /**
     * Add item to EmploymentHistoryRecord value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\EmploymentHistoryRecord $item
     * @return \AcumaticaConfig\StructType\EmploymentHistory
     */
    public function addToEmploymentHistoryRecord(\AcumaticaConfig\StructType\EmploymentHistoryRecord $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\EmploymentHistoryRecord) {
            throw new \InvalidArgumentException(sprintf('The EmploymentHistoryRecord property can only contain items of \AcumaticaConfig\StructType\EmploymentHistoryRecord, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EmploymentHistoryRecord[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\EmploymentHistory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
