<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventAttendee StructType
 * @subpackage Structs
 */
class EventAttendee extends Entity
{
    /**
     * The Comment
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Comment;
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Email;
    /**
     * The EventNoteID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\GuidValue
     */
    public $EventNoteID;
    /**
     * The InvitationStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $InvitationStatus;
    /**
     * The Key
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Key;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Name;
    /**
     * The NameAttendeeName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $NameAttendeeName;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $Type;
    /**
     * Constructor method for EventAttendee
     * @uses EventAttendee::setComment()
     * @uses EventAttendee::setEmail()
     * @uses EventAttendee::setEventNoteID()
     * @uses EventAttendee::setInvitationStatus()
     * @uses EventAttendee::setKey()
     * @uses EventAttendee::setName()
     * @uses EventAttendee::setNameAttendeeName()
     * @uses EventAttendee::setType()
     * @param \AcumaticaConfig\StructType\StringValue $comment
     * @param \AcumaticaConfig\StructType\StringValue $email
     * @param \AcumaticaConfig\StructType\GuidValue $eventNoteID
     * @param \AcumaticaConfig\StructType\StringValue $invitationStatus
     * @param \AcumaticaConfig\StructType\StringValue $key
     * @param \AcumaticaConfig\StructType\StringValue $name
     * @param \AcumaticaConfig\StructType\StringValue $nameAttendeeName
     * @param \AcumaticaConfig\StructType\IntValue $type
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $comment = null, \AcumaticaConfig\StructType\StringValue $email = null, \AcumaticaConfig\StructType\GuidValue $eventNoteID = null, \AcumaticaConfig\StructType\StringValue $invitationStatus = null, \AcumaticaConfig\StructType\StringValue $key = null, \AcumaticaConfig\StructType\StringValue $name = null, \AcumaticaConfig\StructType\StringValue $nameAttendeeName = null, \AcumaticaConfig\StructType\IntValue $type = null)
    {
        $this
            ->setComment($comment)
            ->setEmail($email)
            ->setEventNoteID($eventNoteID)
            ->setInvitationStatus($invitationStatus)
            ->setKey($key)
            ->setName($name)
            ->setNameAttendeeName($nameAttendeeName)
            ->setType($type);
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $comment
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setComment(\AcumaticaConfig\StructType\StringValue $comment = null)
    {
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get Email value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getEmail()
    {
        return isset($this->Email) ? $this->Email : null;
    }
    /**
     * Set Email value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $email
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setEmail(\AcumaticaConfig\StructType\StringValue $email = null)
    {
        if (is_null($email) || (is_array($email) && empty($email))) {
            unset($this->Email);
        } else {
            $this->Email = $email;
        }
        return $this;
    }
    /**
     * Get EventNoteID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\GuidValue|null
     */
    public function getEventNoteID()
    {
        return isset($this->EventNoteID) ? $this->EventNoteID : null;
    }
    /**
     * Set EventNoteID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\GuidValue $eventNoteID
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setEventNoteID(\AcumaticaConfig\StructType\GuidValue $eventNoteID = null)
    {
        if (is_null($eventNoteID) || (is_array($eventNoteID) && empty($eventNoteID))) {
            unset($this->EventNoteID);
        } else {
            $this->EventNoteID = $eventNoteID;
        }
        return $this;
    }
    /**
     * Get InvitationStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getInvitationStatus()
    {
        return isset($this->InvitationStatus) ? $this->InvitationStatus : null;
    }
    /**
     * Set InvitationStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $invitationStatus
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setInvitationStatus(\AcumaticaConfig\StructType\StringValue $invitationStatus = null)
    {
        if (is_null($invitationStatus) || (is_array($invitationStatus) && empty($invitationStatus))) {
            unset($this->InvitationStatus);
        } else {
            $this->InvitationStatus = $invitationStatus;
        }
        return $this;
    }
    /**
     * Get Key value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getKey()
    {
        return isset($this->Key) ? $this->Key : null;
    }
    /**
     * Set Key value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $key
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setKey(\AcumaticaConfig\StructType\StringValue $key = null)
    {
        if (is_null($key) || (is_array($key) && empty($key))) {
            unset($this->Key);
        } else {
            $this->Key = $key;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $name
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setName(\AcumaticaConfig\StructType\StringValue $name = null)
    {
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get NameAttendeeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getNameAttendeeName()
    {
        return isset($this->NameAttendeeName) ? $this->NameAttendeeName : null;
    }
    /**
     * Set NameAttendeeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $nameAttendeeName
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setNameAttendeeName(\AcumaticaConfig\StructType\StringValue $nameAttendeeName = null)
    {
        if (is_null($nameAttendeeName) || (is_array($nameAttendeeName) && empty($nameAttendeeName))) {
            unset($this->NameAttendeeName);
        } else {
            $this->NameAttendeeName = $nameAttendeeName;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $type
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public function setType(\AcumaticaConfig\StructType\IntValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\EventAttendee
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
