<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GLTransactions StructType
 * @subpackage Structs
 */
class GLTransactions extends AbstractStructBase
{
    /**
     * The JournalVoucherGLTransaction
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\JournalVoucherGLTransaction[]
     */
    public $JournalVoucherGLTransaction;
    /**
     * Constructor method for GLTransactions
     * @uses GLTransactions::setJournalVoucherGLTransaction()
     * @param \AcumaticaConfig\StructType\JournalVoucherGLTransaction[] $journalVoucherGLTransaction
     */
    public function __construct(array $journalVoucherGLTransaction = array())
    {
        $this
            ->setJournalVoucherGLTransaction($journalVoucherGLTransaction);
    }
    /**
     * Get JournalVoucherGLTransaction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\JournalVoucherGLTransaction[]|null
     */
    public function getJournalVoucherGLTransaction()
    {
        return isset($this->JournalVoucherGLTransaction) ? $this->JournalVoucherGLTransaction : null;
    }
    /**
     * Set JournalVoucherGLTransaction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\JournalVoucherGLTransaction[] $journalVoucherGLTransaction
     * @return \AcumaticaConfig\StructType\GLTransactions
     */
    public function setJournalVoucherGLTransaction(array $journalVoucherGLTransaction = array())
    {
        foreach ($journalVoucherGLTransaction as $gLTransactionsJournalVoucherGLTransactionItem) {
            // validation for constraint: itemType
            if (!$gLTransactionsJournalVoucherGLTransactionItem instanceof \AcumaticaConfig\StructType\JournalVoucherGLTransaction) {
                throw new \InvalidArgumentException(sprintf('The JournalVoucherGLTransaction property can only contain items of \AcumaticaConfig\StructType\JournalVoucherGLTransaction, "%s" given', is_object($gLTransactionsJournalVoucherGLTransactionItem) ? get_class($gLTransactionsJournalVoucherGLTransactionItem) : gettype($gLTransactionsJournalVoucherGLTransactionItem)), __LINE__);
            }
        }
        if (is_null($journalVoucherGLTransaction) || (is_array($journalVoucherGLTransaction) && empty($journalVoucherGLTransaction))) {
            unset($this->JournalVoucherGLTransaction);
        } else {
            $this->JournalVoucherGLTransaction = $journalVoucherGLTransaction;
        }
        return $this;
    }
    /**
     * Add item to JournalVoucherGLTransaction value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\JournalVoucherGLTransaction $item
     * @return \AcumaticaConfig\StructType\GLTransactions
     */
    public function addToJournalVoucherGLTransaction(\AcumaticaConfig\StructType\JournalVoucherGLTransaction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\JournalVoucherGLTransaction) {
            throw new \InvalidArgumentException(sprintf('The JournalVoucherGLTransaction property can only contain items of \AcumaticaConfig\StructType\JournalVoucherGLTransaction, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->JournalVoucherGLTransaction[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\GLTransactions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
