<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryAllocationRow StructType
 * @subpackage Structs
 */
class InventoryAllocationRow extends Entity
{
    /**
     * The AllocationDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $AllocationDate;
    /**
     * The AllocationType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $AllocationType;
    /**
     * The DocType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $DocType;
    /**
     * The Expired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $Expired;
    /**
     * The Location
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Location;
    /**
     * The LotSerialNbr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $LotSerialNbr;
    /**
     * The Module
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Module;
    /**
     * The Qty
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $Qty;
    /**
     * Constructor method for InventoryAllocationRow
     * @uses InventoryAllocationRow::setAllocationDate()
     * @uses InventoryAllocationRow::setAllocationType()
     * @uses InventoryAllocationRow::setDocType()
     * @uses InventoryAllocationRow::setExpired()
     * @uses InventoryAllocationRow::setLocation()
     * @uses InventoryAllocationRow::setLotSerialNbr()
     * @uses InventoryAllocationRow::setModule()
     * @uses InventoryAllocationRow::setQty()
     * @param \AcumaticaConfig\StructType\DateTimeValue $allocationDate
     * @param \AcumaticaConfig\StructType\StringValue $allocationType
     * @param \AcumaticaConfig\StructType\StringValue $docType
     * @param \AcumaticaConfig\StructType\BooleanValue $expired
     * @param \AcumaticaConfig\StructType\StringValue $location
     * @param \AcumaticaConfig\StructType\StringValue $lotSerialNbr
     * @param \AcumaticaConfig\StructType\StringValue $module
     * @param \AcumaticaConfig\StructType\DecimalValue $qty
     */
    public function __construct(\AcumaticaConfig\StructType\DateTimeValue $allocationDate = null, \AcumaticaConfig\StructType\StringValue $allocationType = null, \AcumaticaConfig\StructType\StringValue $docType = null, \AcumaticaConfig\StructType\BooleanValue $expired = null, \AcumaticaConfig\StructType\StringValue $location = null, \AcumaticaConfig\StructType\StringValue $lotSerialNbr = null, \AcumaticaConfig\StructType\StringValue $module = null, \AcumaticaConfig\StructType\DecimalValue $qty = null)
    {
        $this
            ->setAllocationDate($allocationDate)
            ->setAllocationType($allocationType)
            ->setDocType($docType)
            ->setExpired($expired)
            ->setLocation($location)
            ->setLotSerialNbr($lotSerialNbr)
            ->setModule($module)
            ->setQty($qty);
    }
    /**
     * Get AllocationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getAllocationDate()
    {
        return isset($this->AllocationDate) ? $this->AllocationDate : null;
    }
    /**
     * Set AllocationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $allocationDate
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setAllocationDate(\AcumaticaConfig\StructType\DateTimeValue $allocationDate = null)
    {
        if (is_null($allocationDate) || (is_array($allocationDate) && empty($allocationDate))) {
            unset($this->AllocationDate);
        } else {
            $this->AllocationDate = $allocationDate;
        }
        return $this;
    }
    /**
     * Get AllocationType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getAllocationType()
    {
        return isset($this->AllocationType) ? $this->AllocationType : null;
    }
    /**
     * Set AllocationType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $allocationType
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setAllocationType(\AcumaticaConfig\StructType\StringValue $allocationType = null)
    {
        if (is_null($allocationType) || (is_array($allocationType) && empty($allocationType))) {
            unset($this->AllocationType);
        } else {
            $this->AllocationType = $allocationType;
        }
        return $this;
    }
    /**
     * Get DocType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDocType()
    {
        return isset($this->DocType) ? $this->DocType : null;
    }
    /**
     * Set DocType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $docType
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setDocType(\AcumaticaConfig\StructType\StringValue $docType = null)
    {
        if (is_null($docType) || (is_array($docType) && empty($docType))) {
            unset($this->DocType);
        } else {
            $this->DocType = $docType;
        }
        return $this;
    }
    /**
     * Get Expired value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getExpired()
    {
        return isset($this->Expired) ? $this->Expired : null;
    }
    /**
     * Set Expired value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $expired
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setExpired(\AcumaticaConfig\StructType\BooleanValue $expired = null)
    {
        if (is_null($expired) || (is_array($expired) && empty($expired))) {
            unset($this->Expired);
        } else {
            $this->Expired = $expired;
        }
        return $this;
    }
    /**
     * Get Location value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getLocation()
    {
        return isset($this->Location) ? $this->Location : null;
    }
    /**
     * Set Location value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $location
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setLocation(\AcumaticaConfig\StructType\StringValue $location = null)
    {
        if (is_null($location) || (is_array($location) && empty($location))) {
            unset($this->Location);
        } else {
            $this->Location = $location;
        }
        return $this;
    }
    /**
     * Get LotSerialNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getLotSerialNbr()
    {
        return isset($this->LotSerialNbr) ? $this->LotSerialNbr : null;
    }
    /**
     * Set LotSerialNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $lotSerialNbr
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setLotSerialNbr(\AcumaticaConfig\StructType\StringValue $lotSerialNbr = null)
    {
        if (is_null($lotSerialNbr) || (is_array($lotSerialNbr) && empty($lotSerialNbr))) {
            unset($this->LotSerialNbr);
        } else {
            $this->LotSerialNbr = $lotSerialNbr;
        }
        return $this;
    }
    /**
     * Get Module value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getModule()
    {
        return isset($this->Module) ? $this->Module : null;
    }
    /**
     * Set Module value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $module
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setModule(\AcumaticaConfig\StructType\StringValue $module = null)
    {
        if (is_null($module) || (is_array($module) && empty($module))) {
            unset($this->Module);
        } else {
            $this->Module = $module;
        }
        return $this;
    }
    /**
     * Get Qty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getQty()
    {
        return isset($this->Qty) ? $this->Qty : null;
    }
    /**
     * Set Qty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $qty
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public function setQty(\AcumaticaConfig\StructType\DecimalValue $qty = null)
    {
        if (is_null($qty) || (is_array($qty) && empty($qty))) {
            unset($this->Qty);
        } else {
            $this->Qty = $qty;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\InventoryAllocationRow
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
