<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemSalesCategory StructType
 * @subpackage Structs
 */
class ItemSalesCategory extends Entity
{
    /**
     * The CategoryID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $CategoryID;
    /**
     * The CategoryInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\CategoryInfo
     */
    public $CategoryInfo;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The LastModifiedDateTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The Members
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\Members
     */
    public $Members;
    /**
     * The ParentCategoryID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $ParentCategoryID;
    /**
     * The Path
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Path;
    /**
     * Constructor method for ItemSalesCategory
     * @uses ItemSalesCategory::setCategoryID()
     * @uses ItemSalesCategory::setCategoryInfo()
     * @uses ItemSalesCategory::setDescription()
     * @uses ItemSalesCategory::setLastModifiedDateTime()
     * @uses ItemSalesCategory::setMembers()
     * @uses ItemSalesCategory::setParentCategoryID()
     * @uses ItemSalesCategory::setPath()
     * @param \AcumaticaConfig\StructType\IntValue $categoryID
     * @param \AcumaticaConfig\StructType\CategoryInfo $categoryInfo
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDateTime
     * @param \AcumaticaConfig\StructType\Members $members
     * @param \AcumaticaConfig\StructType\IntValue $parentCategoryID
     * @param \AcumaticaConfig\StructType\StringValue $path
     */
    public function __construct(\AcumaticaConfig\StructType\IntValue $categoryID = null, \AcumaticaConfig\StructType\CategoryInfo $categoryInfo = null, \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDateTime = null, \AcumaticaConfig\StructType\Members $members = null, \AcumaticaConfig\StructType\IntValue $parentCategoryID = null, \AcumaticaConfig\StructType\StringValue $path = null)
    {
        $this
            ->setCategoryID($categoryID)
            ->setCategoryInfo($categoryInfo)
            ->setDescription($description)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setMembers($members)
            ->setParentCategoryID($parentCategoryID)
            ->setPath($path);
    }
    /**
     * Get CategoryID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getCategoryID()
    {
        return isset($this->CategoryID) ? $this->CategoryID : null;
    }
    /**
     * Set CategoryID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $categoryID
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setCategoryID(\AcumaticaConfig\StructType\IntValue $categoryID = null)
    {
        if (is_null($categoryID) || (is_array($categoryID) && empty($categoryID))) {
            unset($this->CategoryID);
        } else {
            $this->CategoryID = $categoryID;
        }
        return $this;
    }
    /**
     * Get CategoryInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\CategoryInfo|null
     */
    public function getCategoryInfo()
    {
        return isset($this->CategoryInfo) ? $this->CategoryInfo : null;
    }
    /**
     * Set CategoryInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\CategoryInfo $categoryInfo
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setCategoryInfo(\AcumaticaConfig\StructType\CategoryInfo $categoryInfo = null)
    {
        if (is_null($categoryInfo) || (is_array($categoryInfo) && empty($categoryInfo))) {
            unset($this->CategoryInfo);
        } else {
            $this->CategoryInfo = $categoryInfo;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $lastModifiedDateTime
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setLastModifiedDateTime(\AcumaticaConfig\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get Members value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\Members|null
     */
    public function getMembers()
    {
        return isset($this->Members) ? $this->Members : null;
    }
    /**
     * Set Members value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\Members $members
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setMembers(\AcumaticaConfig\StructType\Members $members = null)
    {
        if (is_null($members) || (is_array($members) && empty($members))) {
            unset($this->Members);
        } else {
            $this->Members = $members;
        }
        return $this;
    }
    /**
     * Get ParentCategoryID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getParentCategoryID()
    {
        return isset($this->ParentCategoryID) ? $this->ParentCategoryID : null;
    }
    /**
     * Set ParentCategoryID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $parentCategoryID
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setParentCategoryID(\AcumaticaConfig\StructType\IntValue $parentCategoryID = null)
    {
        if (is_null($parentCategoryID) || (is_array($parentCategoryID) && empty($parentCategoryID))) {
            unset($this->ParentCategoryID);
        } else {
            $this->ParentCategoryID = $parentCategoryID;
        }
        return $this;
    }
    /**
     * Get Path value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPath()
    {
        return isset($this->Path) ? $this->Path : null;
    }
    /**
     * Set Path value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $path
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public function setPath(\AcumaticaConfig\StructType\StringValue $path = null)
    {
        if (is_null($path) || (is_array($path) && empty($path))) {
            unset($this->Path);
        } else {
            $this->Path = $path;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ItemSalesCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
