<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OpportunityDetail StructType
 * @subpackage Structs
 */
class OpportunityDetail extends Entity
{
    /**
     * The Currency
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Currency;
    /**
     * The DisplayName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $DisplayName;
    /**
     * The Estimation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $Estimation;
    /**
     * The Owner
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Owner;
    /**
     * The Probability
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $Probability;
    /**
     * The Stage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Stage;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Status;
    /**
     * The Subject
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Subject;
    /**
     * The Total
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $Total;
    /**
     * The Workgroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Workgroup;
    /**
     * Constructor method for OpportunityDetail
     * @uses OpportunityDetail::setCurrency()
     * @uses OpportunityDetail::setDisplayName()
     * @uses OpportunityDetail::setEstimation()
     * @uses OpportunityDetail::setOwner()
     * @uses OpportunityDetail::setProbability()
     * @uses OpportunityDetail::setStage()
     * @uses OpportunityDetail::setStatus()
     * @uses OpportunityDetail::setSubject()
     * @uses OpportunityDetail::setTotal()
     * @uses OpportunityDetail::setWorkgroup()
     * @param \AcumaticaConfig\StructType\StringValue $currency
     * @param \AcumaticaConfig\StructType\StringValue $displayName
     * @param \AcumaticaConfig\StructType\DateTimeValue $estimation
     * @param \AcumaticaConfig\StructType\StringValue $owner
     * @param \AcumaticaConfig\StructType\IntValue $probability
     * @param \AcumaticaConfig\StructType\StringValue $stage
     * @param \AcumaticaConfig\StructType\StringValue $status
     * @param \AcumaticaConfig\StructType\StringValue $subject
     * @param \AcumaticaConfig\StructType\DecimalValue $total
     * @param \AcumaticaConfig\StructType\StringValue $workgroup
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $currency = null, \AcumaticaConfig\StructType\StringValue $displayName = null, \AcumaticaConfig\StructType\DateTimeValue $estimation = null, \AcumaticaConfig\StructType\StringValue $owner = null, \AcumaticaConfig\StructType\IntValue $probability = null, \AcumaticaConfig\StructType\StringValue $stage = null, \AcumaticaConfig\StructType\StringValue $status = null, \AcumaticaConfig\StructType\StringValue $subject = null, \AcumaticaConfig\StructType\DecimalValue $total = null, \AcumaticaConfig\StructType\StringValue $workgroup = null)
    {
        $this
            ->setCurrency($currency)
            ->setDisplayName($displayName)
            ->setEstimation($estimation)
            ->setOwner($owner)
            ->setProbability($probability)
            ->setStage($stage)
            ->setStatus($status)
            ->setSubject($subject)
            ->setTotal($total)
            ->setWorkgroup($workgroup);
    }
    /**
     * Get Currency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getCurrency()
    {
        return isset($this->Currency) ? $this->Currency : null;
    }
    /**
     * Set Currency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $currency
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setCurrency(\AcumaticaConfig\StructType\StringValue $currency = null)
    {
        if (is_null($currency) || (is_array($currency) && empty($currency))) {
            unset($this->Currency);
        } else {
            $this->Currency = $currency;
        }
        return $this;
    }
    /**
     * Get DisplayName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDisplayName()
    {
        return isset($this->DisplayName) ? $this->DisplayName : null;
    }
    /**
     * Set DisplayName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $displayName
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setDisplayName(\AcumaticaConfig\StructType\StringValue $displayName = null)
    {
        if (is_null($displayName) || (is_array($displayName) && empty($displayName))) {
            unset($this->DisplayName);
        } else {
            $this->DisplayName = $displayName;
        }
        return $this;
    }
    /**
     * Get Estimation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getEstimation()
    {
        return isset($this->Estimation) ? $this->Estimation : null;
    }
    /**
     * Set Estimation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $estimation
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setEstimation(\AcumaticaConfig\StructType\DateTimeValue $estimation = null)
    {
        if (is_null($estimation) || (is_array($estimation) && empty($estimation))) {
            unset($this->Estimation);
        } else {
            $this->Estimation = $estimation;
        }
        return $this;
    }
    /**
     * Get Owner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getOwner()
    {
        return isset($this->Owner) ? $this->Owner : null;
    }
    /**
     * Set Owner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $owner
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setOwner(\AcumaticaConfig\StructType\StringValue $owner = null)
    {
        if (is_null($owner) || (is_array($owner) && empty($owner))) {
            unset($this->Owner);
        } else {
            $this->Owner = $owner;
        }
        return $this;
    }
    /**
     * Get Probability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getProbability()
    {
        return isset($this->Probability) ? $this->Probability : null;
    }
    /**
     * Set Probability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $probability
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setProbability(\AcumaticaConfig\StructType\IntValue $probability = null)
    {
        if (is_null($probability) || (is_array($probability) && empty($probability))) {
            unset($this->Probability);
        } else {
            $this->Probability = $probability;
        }
        return $this;
    }
    /**
     * Get Stage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getStage()
    {
        return isset($this->Stage) ? $this->Stage : null;
    }
    /**
     * Set Stage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $stage
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setStage(\AcumaticaConfig\StructType\StringValue $stage = null)
    {
        if (is_null($stage) || (is_array($stage) && empty($stage))) {
            unset($this->Stage);
        } else {
            $this->Stage = $stage;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $status
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setStatus(\AcumaticaConfig\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Subject value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getSubject()
    {
        return isset($this->Subject) ? $this->Subject : null;
    }
    /**
     * Set Subject value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $subject
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setSubject(\AcumaticaConfig\StructType\StringValue $subject = null)
    {
        if (is_null($subject) || (is_array($subject) && empty($subject))) {
            unset($this->Subject);
        } else {
            $this->Subject = $subject;
        }
        return $this;
    }
    /**
     * Get Total value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getTotal()
    {
        return isset($this->Total) ? $this->Total : null;
    }
    /**
     * Set Total value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $total
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setTotal(\AcumaticaConfig\StructType\DecimalValue $total = null)
    {
        if (is_null($total) || (is_array($total) && empty($total))) {
            unset($this->Total);
        } else {
            $this->Total = $total;
        }
        return $this;
    }
    /**
     * Get Workgroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getWorkgroup()
    {
        return isset($this->Workgroup) ? $this->Workgroup : null;
    }
    /**
     * Set Workgroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $workgroup
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public function setWorkgroup(\AcumaticaConfig\StructType\StringValue $workgroup = null)
    {
        if (is_null($workgroup) || (is_array($workgroup) && empty($workgroup))) {
            unset($this->Workgroup);
        } else {
            $this->Workgroup = $workgroup;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\OpportunityDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
