<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhysicalInventoryReview StructType
 * @subpackage Structs
 */
class PhysicalInventoryReview extends Entity
{
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The Details
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\Details
     */
    public $Details;
    /**
     * The FreezeDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $FreezeDate;
    /**
     * The ReferenceNbr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $ReferenceNbr;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Status;
    /**
     * The TotalPhysicalQty
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $TotalPhysicalQty;
    /**
     * The TotalVarianceCost
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $TotalVarianceCost;
    /**
     * The TotalVarianceQty
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $TotalVarianceQty;
    /**
     * The TypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $TypeID;
    /**
     * The WarehouseID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $WarehouseID;
    /**
     * Constructor method for PhysicalInventoryReview
     * @uses PhysicalInventoryReview::setDescription()
     * @uses PhysicalInventoryReview::setDetails()
     * @uses PhysicalInventoryReview::setFreezeDate()
     * @uses PhysicalInventoryReview::setReferenceNbr()
     * @uses PhysicalInventoryReview::setStatus()
     * @uses PhysicalInventoryReview::setTotalPhysicalQty()
     * @uses PhysicalInventoryReview::setTotalVarianceCost()
     * @uses PhysicalInventoryReview::setTotalVarianceQty()
     * @uses PhysicalInventoryReview::setTypeID()
     * @uses PhysicalInventoryReview::setWarehouseID()
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\Details $details
     * @param \AcumaticaConfig\StructType\DateTimeValue $freezeDate
     * @param \AcumaticaConfig\StructType\StringValue $referenceNbr
     * @param \AcumaticaConfig\StructType\StringValue $status
     * @param \AcumaticaConfig\StructType\DecimalValue $totalPhysicalQty
     * @param \AcumaticaConfig\StructType\DecimalValue $totalVarianceCost
     * @param \AcumaticaConfig\StructType\DecimalValue $totalVarianceQty
     * @param \AcumaticaConfig\StructType\StringValue $typeID
     * @param \AcumaticaConfig\StructType\StringValue $warehouseID
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\Details $details = null, \AcumaticaConfig\StructType\DateTimeValue $freezeDate = null, \AcumaticaConfig\StructType\StringValue $referenceNbr = null, \AcumaticaConfig\StructType\StringValue $status = null, \AcumaticaConfig\StructType\DecimalValue $totalPhysicalQty = null, \AcumaticaConfig\StructType\DecimalValue $totalVarianceCost = null, \AcumaticaConfig\StructType\DecimalValue $totalVarianceQty = null, \AcumaticaConfig\StructType\StringValue $typeID = null, \AcumaticaConfig\StructType\StringValue $warehouseID = null)
    {
        $this
            ->setDescription($description)
            ->setDetails($details)
            ->setFreezeDate($freezeDate)
            ->setReferenceNbr($referenceNbr)
            ->setStatus($status)
            ->setTotalPhysicalQty($totalPhysicalQty)
            ->setTotalVarianceCost($totalVarianceCost)
            ->setTotalVarianceQty($totalVarianceQty)
            ->setTypeID($typeID)
            ->setWarehouseID($warehouseID);
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\Details|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\Details $details
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setDetails(\AcumaticaConfig\StructType\Details $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get FreezeDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getFreezeDate()
    {
        return isset($this->FreezeDate) ? $this->FreezeDate : null;
    }
    /**
     * Set FreezeDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $freezeDate
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setFreezeDate(\AcumaticaConfig\StructType\DateTimeValue $freezeDate = null)
    {
        if (is_null($freezeDate) || (is_array($freezeDate) && empty($freezeDate))) {
            unset($this->FreezeDate);
        } else {
            $this->FreezeDate = $freezeDate;
        }
        return $this;
    }
    /**
     * Get ReferenceNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getReferenceNbr()
    {
        return isset($this->ReferenceNbr) ? $this->ReferenceNbr : null;
    }
    /**
     * Set ReferenceNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $referenceNbr
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setReferenceNbr(\AcumaticaConfig\StructType\StringValue $referenceNbr = null)
    {
        if (is_null($referenceNbr) || (is_array($referenceNbr) && empty($referenceNbr))) {
            unset($this->ReferenceNbr);
        } else {
            $this->ReferenceNbr = $referenceNbr;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $status
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setStatus(\AcumaticaConfig\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get TotalPhysicalQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getTotalPhysicalQty()
    {
        return isset($this->TotalPhysicalQty) ? $this->TotalPhysicalQty : null;
    }
    /**
     * Set TotalPhysicalQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $totalPhysicalQty
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setTotalPhysicalQty(\AcumaticaConfig\StructType\DecimalValue $totalPhysicalQty = null)
    {
        if (is_null($totalPhysicalQty) || (is_array($totalPhysicalQty) && empty($totalPhysicalQty))) {
            unset($this->TotalPhysicalQty);
        } else {
            $this->TotalPhysicalQty = $totalPhysicalQty;
        }
        return $this;
    }
    /**
     * Get TotalVarianceCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getTotalVarianceCost()
    {
        return isset($this->TotalVarianceCost) ? $this->TotalVarianceCost : null;
    }
    /**
     * Set TotalVarianceCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $totalVarianceCost
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setTotalVarianceCost(\AcumaticaConfig\StructType\DecimalValue $totalVarianceCost = null)
    {
        if (is_null($totalVarianceCost) || (is_array($totalVarianceCost) && empty($totalVarianceCost))) {
            unset($this->TotalVarianceCost);
        } else {
            $this->TotalVarianceCost = $totalVarianceCost;
        }
        return $this;
    }
    /**
     * Get TotalVarianceQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getTotalVarianceQty()
    {
        return isset($this->TotalVarianceQty) ? $this->TotalVarianceQty : null;
    }
    /**
     * Set TotalVarianceQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $totalVarianceQty
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setTotalVarianceQty(\AcumaticaConfig\StructType\DecimalValue $totalVarianceQty = null)
    {
        if (is_null($totalVarianceQty) || (is_array($totalVarianceQty) && empty($totalVarianceQty))) {
            unset($this->TotalVarianceQty);
        } else {
            $this->TotalVarianceQty = $totalVarianceQty;
        }
        return $this;
    }
    /**
     * Get TypeID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTypeID()
    {
        return isset($this->TypeID) ? $this->TypeID : null;
    }
    /**
     * Set TypeID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $typeID
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setTypeID(\AcumaticaConfig\StructType\StringValue $typeID = null)
    {
        if (is_null($typeID) || (is_array($typeID) && empty($typeID))) {
            unset($this->TypeID);
        } else {
            $this->TypeID = $typeID;
        }
        return $this;
    }
    /**
     * Get WarehouseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getWarehouseID()
    {
        return isset($this->WarehouseID) ? $this->WarehouseID : null;
    }
    /**
     * Set WarehouseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $warehouseID
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public function setWarehouseID(\AcumaticaConfig\StructType\StringValue $warehouseID = null)
    {
        if (is_null($warehouseID) || (is_array($warehouseID) && empty($warehouseID))) {
            unset($this->WarehouseID);
        } else {
            $this->WarehouseID = $warehouseID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\PhysicalInventoryReview
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
