<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlugInParameters StructType
 * @subpackage Structs
 */
class PlugInParameters extends AbstractStructBase
{
    /**
     * The CarrierPluginParameter
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\CarrierPluginParameter[]
     */
    public $CarrierPluginParameter;
    /**
     * Constructor method for PlugInParameters
     * @uses PlugInParameters::setCarrierPluginParameter()
     * @param \AcumaticaConfig\StructType\CarrierPluginParameter[] $carrierPluginParameter
     */
    public function __construct(array $carrierPluginParameter = array())
    {
        $this
            ->setCarrierPluginParameter($carrierPluginParameter);
    }
    /**
     * Get CarrierPluginParameter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\CarrierPluginParameter[]|null
     */
    public function getCarrierPluginParameter()
    {
        return isset($this->CarrierPluginParameter) ? $this->CarrierPluginParameter : null;
    }
    /**
     * Set CarrierPluginParameter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CarrierPluginParameter[] $carrierPluginParameter
     * @return \AcumaticaConfig\StructType\PlugInParameters
     */
    public function setCarrierPluginParameter(array $carrierPluginParameter = array())
    {
        foreach ($carrierPluginParameter as $plugInParametersCarrierPluginParameterItem) {
            // validation for constraint: itemType
            if (!$plugInParametersCarrierPluginParameterItem instanceof \AcumaticaConfig\StructType\CarrierPluginParameter) {
                throw new \InvalidArgumentException(sprintf('The CarrierPluginParameter property can only contain items of \AcumaticaConfig\StructType\CarrierPluginParameter, "%s" given', is_object($plugInParametersCarrierPluginParameterItem) ? get_class($plugInParametersCarrierPluginParameterItem) : gettype($plugInParametersCarrierPluginParameterItem)), __LINE__);
            }
        }
        if (is_null($carrierPluginParameter) || (is_array($carrierPluginParameter) && empty($carrierPluginParameter))) {
            unset($this->CarrierPluginParameter);
        } else {
            $this->CarrierPluginParameter = $carrierPluginParameter;
        }
        return $this;
    }
    /**
     * Add item to CarrierPluginParameter value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CarrierPluginParameter $item
     * @return \AcumaticaConfig\StructType\PlugInParameters
     */
    public function addToCarrierPluginParameter(\AcumaticaConfig\StructType\CarrierPluginParameter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\CarrierPluginParameter) {
            throw new \InvalidArgumentException(sprintf('The CarrierPluginParameter property can only contain items of \AcumaticaConfig\StructType\CarrierPluginParameter, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CarrierPluginParameter[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\PlugInParameters
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
