<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PurchaseSettings StructType
 * @subpackage Structs
 */
class PurchaseSettings extends Entity
{
    /**
     * The POSiteID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $POSiteID;
    /**
     * The POSource
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $POSource;
    /**
     * The VendorID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $VendorID;
    /**
     * Constructor method for PurchaseSettings
     * @uses PurchaseSettings::setPOSiteID()
     * @uses PurchaseSettings::setPOSource()
     * @uses PurchaseSettings::setVendorID()
     * @param \AcumaticaConfig\StructType\StringValue $pOSiteID
     * @param \AcumaticaConfig\StructType\StringValue $pOSource
     * @param \AcumaticaConfig\StructType\StringValue $vendorID
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $pOSiteID = null, \AcumaticaConfig\StructType\StringValue $pOSource = null, \AcumaticaConfig\StructType\StringValue $vendorID = null)
    {
        $this
            ->setPOSiteID($pOSiteID)
            ->setPOSource($pOSource)
            ->setVendorID($vendorID);
    }
    /**
     * Get POSiteID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPOSiteID()
    {
        return isset($this->POSiteID) ? $this->POSiteID : null;
    }
    /**
     * Set POSiteID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $pOSiteID
     * @return \AcumaticaConfig\StructType\PurchaseSettings
     */
    public function setPOSiteID(\AcumaticaConfig\StructType\StringValue $pOSiteID = null)
    {
        if (is_null($pOSiteID) || (is_array($pOSiteID) && empty($pOSiteID))) {
            unset($this->POSiteID);
        } else {
            $this->POSiteID = $pOSiteID;
        }
        return $this;
    }
    /**
     * Get POSource value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPOSource()
    {
        return isset($this->POSource) ? $this->POSource : null;
    }
    /**
     * Set POSource value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $pOSource
     * @return \AcumaticaConfig\StructType\PurchaseSettings
     */
    public function setPOSource(\AcumaticaConfig\StructType\StringValue $pOSource = null)
    {
        if (is_null($pOSource) || (is_array($pOSource) && empty($pOSource))) {
            unset($this->POSource);
        } else {
            $this->POSource = $pOSource;
        }
        return $this;
    }
    /**
     * Get VendorID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getVendorID()
    {
        return isset($this->VendorID) ? $this->VendorID : null;
    }
    /**
     * Set VendorID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $vendorID
     * @return \AcumaticaConfig\StructType\PurchaseSettings
     */
    public function setVendorID(\AcumaticaConfig\StructType\StringValue $vendorID = null)
    {
        if (is_null($vendorID) || (is_array($vendorID) && empty($vendorID))) {
            unset($this->VendorID);
        } else {
            $this->VendorID = $vendorID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\PurchaseSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
