<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RelatedCases StructType
 * @subpackage Structs
 */
class RelatedCases extends AbstractStructBase
{
    /**
     * The CaseRelatedCase
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\CaseRelatedCase[]
     */
    public $CaseRelatedCase;
    /**
     * Constructor method for RelatedCases
     * @uses RelatedCases::setCaseRelatedCase()
     * @param \AcumaticaConfig\StructType\CaseRelatedCase[] $caseRelatedCase
     */
    public function __construct(array $caseRelatedCase = array())
    {
        $this
            ->setCaseRelatedCase($caseRelatedCase);
    }
    /**
     * Get CaseRelatedCase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\CaseRelatedCase[]|null
     */
    public function getCaseRelatedCase()
    {
        return isset($this->CaseRelatedCase) ? $this->CaseRelatedCase : null;
    }
    /**
     * Set CaseRelatedCase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CaseRelatedCase[] $caseRelatedCase
     * @return \AcumaticaConfig\StructType\RelatedCases
     */
    public function setCaseRelatedCase(array $caseRelatedCase = array())
    {
        foreach ($caseRelatedCase as $relatedCasesCaseRelatedCaseItem) {
            // validation for constraint: itemType
            if (!$relatedCasesCaseRelatedCaseItem instanceof \AcumaticaConfig\StructType\CaseRelatedCase) {
                throw new \InvalidArgumentException(sprintf('The CaseRelatedCase property can only contain items of \AcumaticaConfig\StructType\CaseRelatedCase, "%s" given', is_object($relatedCasesCaseRelatedCaseItem) ? get_class($relatedCasesCaseRelatedCaseItem) : gettype($relatedCasesCaseRelatedCaseItem)), __LINE__);
            }
        }
        if (is_null($caseRelatedCase) || (is_array($caseRelatedCase) && empty($caseRelatedCase))) {
            unset($this->CaseRelatedCase);
        } else {
            $this->CaseRelatedCase = $caseRelatedCase;
        }
        return $this;
    }
    /**
     * Add item to CaseRelatedCase value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\CaseRelatedCase $item
     * @return \AcumaticaConfig\StructType\RelatedCases
     */
    public function addToCaseRelatedCase(\AcumaticaConfig\StructType\CaseRelatedCase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\CaseRelatedCase) {
            throw new \InvalidArgumentException(sprintf('The CaseRelatedCase property can only contain items of \AcumaticaConfig\StructType\CaseRelatedCase, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CaseRelatedCase[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\RelatedCases
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
