<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RelatedTasks StructType
 * @subpackage Structs
 */
class RelatedTasks extends AbstractStructBase
{
    /**
     * The TaskRelatedTask
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\TaskRelatedTask[]
     */
    public $TaskRelatedTask;
    /**
     * Constructor method for RelatedTasks
     * @uses RelatedTasks::setTaskRelatedTask()
     * @param \AcumaticaConfig\StructType\TaskRelatedTask[] $taskRelatedTask
     */
    public function __construct(array $taskRelatedTask = array())
    {
        $this
            ->setTaskRelatedTask($taskRelatedTask);
    }
    /**
     * Get TaskRelatedTask value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\TaskRelatedTask[]|null
     */
    public function getTaskRelatedTask()
    {
        return isset($this->TaskRelatedTask) ? $this->TaskRelatedTask : null;
    }
    /**
     * Set TaskRelatedTask value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\TaskRelatedTask[] $taskRelatedTask
     * @return \AcumaticaConfig\StructType\RelatedTasks
     */
    public function setTaskRelatedTask(array $taskRelatedTask = array())
    {
        foreach ($taskRelatedTask as $relatedTasksTaskRelatedTaskItem) {
            // validation for constraint: itemType
            if (!$relatedTasksTaskRelatedTaskItem instanceof \AcumaticaConfig\StructType\TaskRelatedTask) {
                throw new \InvalidArgumentException(sprintf('The TaskRelatedTask property can only contain items of \AcumaticaConfig\StructType\TaskRelatedTask, "%s" given', is_object($relatedTasksTaskRelatedTaskItem) ? get_class($relatedTasksTaskRelatedTaskItem) : gettype($relatedTasksTaskRelatedTaskItem)), __LINE__);
            }
        }
        if (is_null($taskRelatedTask) || (is_array($taskRelatedTask) && empty($taskRelatedTask))) {
            unset($this->TaskRelatedTask);
        } else {
            $this->TaskRelatedTask = $taskRelatedTask;
        }
        return $this;
    }
    /**
     * Add item to TaskRelatedTask value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\TaskRelatedTask $item
     * @return \AcumaticaConfig\StructType\RelatedTasks
     */
    public function addToTaskRelatedTask(\AcumaticaConfig\StructType\TaskRelatedTask $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\TaskRelatedTask) {
            throw new \InvalidArgumentException(sprintf('The TaskRelatedTask property can only contain items of \AcumaticaConfig\StructType\TaskRelatedTask, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TaskRelatedTask[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\RelatedTasks
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
