<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReplenishmentParameters StructType
 * @subpackage Structs
 */
class ReplenishmentParameters extends AbstractStructBase
{
    /**
     * The ReplenishmentParameterStockItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ReplenishmentParameterStockItem[]
     */
    public $ReplenishmentParameterStockItem;
    /**
     * Constructor method for ReplenishmentParameters
     * @uses ReplenishmentParameters::setReplenishmentParameterStockItem()
     * @param \AcumaticaConfig\StructType\ReplenishmentParameterStockItem[] $replenishmentParameterStockItem
     */
    public function __construct(array $replenishmentParameterStockItem = array())
    {
        $this
            ->setReplenishmentParameterStockItem($replenishmentParameterStockItem);
    }
    /**
     * Get ReplenishmentParameterStockItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ReplenishmentParameterStockItem[]|null
     */
    public function getReplenishmentParameterStockItem()
    {
        return isset($this->ReplenishmentParameterStockItem) ? $this->ReplenishmentParameterStockItem : null;
    }
    /**
     * Set ReplenishmentParameterStockItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ReplenishmentParameterStockItem[] $replenishmentParameterStockItem
     * @return \AcumaticaConfig\StructType\ReplenishmentParameters
     */
    public function setReplenishmentParameterStockItem(array $replenishmentParameterStockItem = array())
    {
        foreach ($replenishmentParameterStockItem as $replenishmentParametersReplenishmentParameterStockItemItem) {
            // validation for constraint: itemType
            if (!$replenishmentParametersReplenishmentParameterStockItemItem instanceof \AcumaticaConfig\StructType\ReplenishmentParameterStockItem) {
                throw new \InvalidArgumentException(sprintf('The ReplenishmentParameterStockItem property can only contain items of \AcumaticaConfig\StructType\ReplenishmentParameterStockItem, "%s" given', is_object($replenishmentParametersReplenishmentParameterStockItemItem) ? get_class($replenishmentParametersReplenishmentParameterStockItemItem) : gettype($replenishmentParametersReplenishmentParameterStockItemItem)), __LINE__);
            }
        }
        if (is_null($replenishmentParameterStockItem) || (is_array($replenishmentParameterStockItem) && empty($replenishmentParameterStockItem))) {
            unset($this->ReplenishmentParameterStockItem);
        } else {
            $this->ReplenishmentParameterStockItem = $replenishmentParameterStockItem;
        }
        return $this;
    }
    /**
     * Add item to ReplenishmentParameterStockItem value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ReplenishmentParameterStockItem $item
     * @return \AcumaticaConfig\StructType\ReplenishmentParameters
     */
    public function addToReplenishmentParameterStockItem(\AcumaticaConfig\StructType\ReplenishmentParameterStockItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\ReplenishmentParameterStockItem) {
            throw new \InvalidArgumentException(sprintf('The ReplenishmentParameterStockItem property can only contain items of \AcumaticaConfig\StructType\ReplenishmentParameterStockItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReplenishmentParameterStockItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ReplenishmentParameters
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
