<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportingGroups StructType
 * @subpackage Structs
 */
class ReportingGroups extends AbstractStructBase
{
    /**
     * The ReportingGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ReportingGroup[]
     */
    public $ReportingGroup;
    /**
     * Constructor method for ReportingGroups
     * @uses ReportingGroups::setReportingGroup()
     * @param \AcumaticaConfig\StructType\ReportingGroup[] $reportingGroup
     */
    public function __construct(array $reportingGroup = array())
    {
        $this
            ->setReportingGroup($reportingGroup);
    }
    /**
     * Get ReportingGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ReportingGroup[]|null
     */
    public function getReportingGroup()
    {
        return isset($this->ReportingGroup) ? $this->ReportingGroup : null;
    }
    /**
     * Set ReportingGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ReportingGroup[] $reportingGroup
     * @return \AcumaticaConfig\StructType\ReportingGroups
     */
    public function setReportingGroup(array $reportingGroup = array())
    {
        foreach ($reportingGroup as $reportingGroupsReportingGroupItem) {
            // validation for constraint: itemType
            if (!$reportingGroupsReportingGroupItem instanceof \AcumaticaConfig\StructType\ReportingGroup) {
                throw new \InvalidArgumentException(sprintf('The ReportingGroup property can only contain items of \AcumaticaConfig\StructType\ReportingGroup, "%s" given', is_object($reportingGroupsReportingGroupItem) ? get_class($reportingGroupsReportingGroupItem) : gettype($reportingGroupsReportingGroupItem)), __LINE__);
            }
        }
        if (is_null($reportingGroup) || (is_array($reportingGroup) && empty($reportingGroup))) {
            unset($this->ReportingGroup);
        } else {
            $this->ReportingGroup = $reportingGroup;
        }
        return $this;
    }
    /**
     * Add item to ReportingGroup value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ReportingGroup $item
     * @return \AcumaticaConfig\StructType\ReportingGroups
     */
    public function addToReportingGroup(\AcumaticaConfig\StructType\ReportingGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\ReportingGroup) {
            throw new \InvalidArgumentException(sprintf('The ReportingGroup property can only contain items of \AcumaticaConfig\StructType\ReportingGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReportingGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ReportingGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
