<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportingSettings StructType
 * @subpackage Structs
 */
class ReportingSettings extends Entity
{
    /**
     * The ReportingGroups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ReportingGroups
     */
    public $ReportingGroups;
    /**
     * The TaxAgency
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $TaxAgency;
    /**
     * Constructor method for ReportingSettings
     * @uses ReportingSettings::setReportingGroups()
     * @uses ReportingSettings::setTaxAgency()
     * @param \AcumaticaConfig\StructType\ReportingGroups $reportingGroups
     * @param \AcumaticaConfig\StructType\StringValue $taxAgency
     */
    public function __construct(\AcumaticaConfig\StructType\ReportingGroups $reportingGroups = null, \AcumaticaConfig\StructType\StringValue $taxAgency = null)
    {
        $this
            ->setReportingGroups($reportingGroups)
            ->setTaxAgency($taxAgency);
    }
    /**
     * Get ReportingGroups value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ReportingGroups|null
     */
    public function getReportingGroups()
    {
        return isset($this->ReportingGroups) ? $this->ReportingGroups : null;
    }
    /**
     * Set ReportingGroups value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\ReportingGroups $reportingGroups
     * @return \AcumaticaConfig\StructType\ReportingSettings
     */
    public function setReportingGroups(\AcumaticaConfig\StructType\ReportingGroups $reportingGroups = null)
    {
        if (is_null($reportingGroups) || (is_array($reportingGroups) && empty($reportingGroups))) {
            unset($this->ReportingGroups);
        } else {
            $this->ReportingGroups = $reportingGroups;
        }
        return $this;
    }
    /**
     * Get TaxAgency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTaxAgency()
    {
        return isset($this->TaxAgency) ? $this->TaxAgency : null;
    }
    /**
     * Set TaxAgency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $taxAgency
     * @return \AcumaticaConfig\StructType\ReportingSettings
     */
    public function setTaxAgency(\AcumaticaConfig\StructType\StringValue $taxAgency = null)
    {
        if (is_null($taxAgency) || (is_array($taxAgency) && empty($taxAgency))) {
            unset($this->TaxAgency);
        } else {
            $this->TaxAgency = $taxAgency;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ReportingSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
