<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Roles StructType
 * @subpackage Structs
 */
class Roles extends AbstractStructBase
{
    /**
     * The ContactRoles
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ContactRoles[]
     */
    public $ContactRoles;
    /**
     * Constructor method for Roles
     * @uses Roles::setContactRoles()
     * @param \AcumaticaConfig\StructType\ContactRoles[] $contactRoles
     */
    public function __construct(array $contactRoles = array())
    {
        $this
            ->setContactRoles($contactRoles);
    }
    /**
     * Get ContactRoles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ContactRoles[]|null
     */
    public function getContactRoles()
    {
        return isset($this->ContactRoles) ? $this->ContactRoles : null;
    }
    /**
     * Set ContactRoles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ContactRoles[] $contactRoles
     * @return \AcumaticaConfig\StructType\Roles
     */
    public function setContactRoles(array $contactRoles = array())
    {
        foreach ($contactRoles as $rolesContactRolesItem) {
            // validation for constraint: itemType
            if (!$rolesContactRolesItem instanceof \AcumaticaConfig\StructType\ContactRoles) {
                throw new \InvalidArgumentException(sprintf('The ContactRoles property can only contain items of \AcumaticaConfig\StructType\ContactRoles, "%s" given', is_object($rolesContactRolesItem) ? get_class($rolesContactRolesItem) : gettype($rolesContactRolesItem)), __LINE__);
            }
        }
        if (is_null($contactRoles) || (is_array($contactRoles) && empty($contactRoles))) {
            unset($this->ContactRoles);
        } else {
            $this->ContactRoles = $contactRoles;
        }
        return $this;
    }
    /**
     * Add item to ContactRoles value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\ContactRoles $item
     * @return \AcumaticaConfig\StructType\Roles
     */
    public function addToContactRoles(\AcumaticaConfig\StructType\ContactRoles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\ContactRoles) {
            throw new \InvalidArgumentException(sprintf('The ContactRoles property can only contain items of \AcumaticaConfig\StructType\ContactRoles, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ContactRoles[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\Roles
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
