<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesPriceDetails StructType
 * @subpackage Structs
 */
class SalesPriceDetails extends AbstractStructBase
{
    /**
     * The SalesPriceDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\SalesPriceDetail[]
     */
    public $SalesPriceDetail;
    /**
     * Constructor method for SalesPriceDetails
     * @uses SalesPriceDetails::setSalesPriceDetail()
     * @param \AcumaticaConfig\StructType\SalesPriceDetail[] $salesPriceDetail
     */
    public function __construct(array $salesPriceDetail = array())
    {
        $this
            ->setSalesPriceDetail($salesPriceDetail);
    }
    /**
     * Get SalesPriceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\SalesPriceDetail[]|null
     */
    public function getSalesPriceDetail()
    {
        return isset($this->SalesPriceDetail) ? $this->SalesPriceDetail : null;
    }
    /**
     * Set SalesPriceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\SalesPriceDetail[] $salesPriceDetail
     * @return \AcumaticaConfig\StructType\SalesPriceDetails
     */
    public function setSalesPriceDetail(array $salesPriceDetail = array())
    {
        foreach ($salesPriceDetail as $salesPriceDetailsSalesPriceDetailItem) {
            // validation for constraint: itemType
            if (!$salesPriceDetailsSalesPriceDetailItem instanceof \AcumaticaConfig\StructType\SalesPriceDetail) {
                throw new \InvalidArgumentException(sprintf('The SalesPriceDetail property can only contain items of \AcumaticaConfig\StructType\SalesPriceDetail, "%s" given', is_object($salesPriceDetailsSalesPriceDetailItem) ? get_class($salesPriceDetailsSalesPriceDetailItem) : gettype($salesPriceDetailsSalesPriceDetailItem)), __LINE__);
            }
        }
        if (is_null($salesPriceDetail) || (is_array($salesPriceDetail) && empty($salesPriceDetail))) {
            unset($this->SalesPriceDetail);
        } else {
            $this->SalesPriceDetail = $salesPriceDetail;
        }
        return $this;
    }
    /**
     * Add item to SalesPriceDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\SalesPriceDetail $item
     * @return \AcumaticaConfig\StructType\SalesPriceDetails
     */
    public function addToSalesPriceDetail(\AcumaticaConfig\StructType\SalesPriceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\SalesPriceDetail) {
            throw new \InvalidArgumentException(sprintf('The SalesPriceDetail property can only contain items of \AcumaticaConfig\StructType\SalesPriceDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SalesPriceDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\SalesPriceDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
