<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesPrices StructType
 * @subpackage Structs
 */
class SalesPrices extends AbstractStructBase
{
    /**
     * The SalesPricesWorksheetDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\SalesPricesWorksheetDetail[]
     */
    public $SalesPricesWorksheetDetail;
    /**
     * Constructor method for SalesPrices
     * @uses SalesPrices::setSalesPricesWorksheetDetail()
     * @param \AcumaticaConfig\StructType\SalesPricesWorksheetDetail[] $salesPricesWorksheetDetail
     */
    public function __construct(array $salesPricesWorksheetDetail = array())
    {
        $this
            ->setSalesPricesWorksheetDetail($salesPricesWorksheetDetail);
    }
    /**
     * Get SalesPricesWorksheetDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\SalesPricesWorksheetDetail[]|null
     */
    public function getSalesPricesWorksheetDetail()
    {
        return isset($this->SalesPricesWorksheetDetail) ? $this->SalesPricesWorksheetDetail : null;
    }
    /**
     * Set SalesPricesWorksheetDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\SalesPricesWorksheetDetail[] $salesPricesWorksheetDetail
     * @return \AcumaticaConfig\StructType\SalesPrices
     */
    public function setSalesPricesWorksheetDetail(array $salesPricesWorksheetDetail = array())
    {
        foreach ($salesPricesWorksheetDetail as $salesPricesSalesPricesWorksheetDetailItem) {
            // validation for constraint: itemType
            if (!$salesPricesSalesPricesWorksheetDetailItem instanceof \AcumaticaConfig\StructType\SalesPricesWorksheetDetail) {
                throw new \InvalidArgumentException(sprintf('The SalesPricesWorksheetDetail property can only contain items of \AcumaticaConfig\StructType\SalesPricesWorksheetDetail, "%s" given', is_object($salesPricesSalesPricesWorksheetDetailItem) ? get_class($salesPricesSalesPricesWorksheetDetailItem) : gettype($salesPricesSalesPricesWorksheetDetailItem)), __LINE__);
            }
        }
        if (is_null($salesPricesWorksheetDetail) || (is_array($salesPricesWorksheetDetail) && empty($salesPricesWorksheetDetail))) {
            unset($this->SalesPricesWorksheetDetail);
        } else {
            $this->SalesPricesWorksheetDetail = $salesPricesWorksheetDetail;
        }
        return $this;
    }
    /**
     * Add item to SalesPricesWorksheetDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\SalesPricesWorksheetDetail $item
     * @return \AcumaticaConfig\StructType\SalesPrices
     */
    public function addToSalesPricesWorksheetDetail(\AcumaticaConfig\StructType\SalesPricesWorksheetDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\SalesPricesWorksheetDetail) {
            throw new \InvalidArgumentException(sprintf('The SalesPricesWorksheetDetail property can only contain items of \AcumaticaConfig\StructType\SalesPricesWorksheetDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SalesPricesWorksheetDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\SalesPrices
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
