<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesPricesInquiry StructType
 * @subpackage Structs
 */
class SalesPricesInquiry extends Entity
{
    /**
     * The EffectiveAsOf
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $EffectiveAsOf;
    /**
     * The InventoryID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $InventoryID;
    /**
     * The ItemClassID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $ItemClassID;
    /**
     * The PriceClass
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $PriceClass;
    /**
     * The PriceCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $PriceCode;
    /**
     * The PriceManager
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $PriceManager;
    /**
     * The PriceManagerIsMe
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $PriceManagerIsMe;
    /**
     * The PriceType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $PriceType;
    /**
     * The PriceWorkgroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $PriceWorkgroup;
    /**
     * The PriceWorkgroupIsMine
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $PriceWorkgroupIsMine;
    /**
     * The SalesPriceDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\SalesPriceDetails
     */
    public $SalesPriceDetails;
    /**
     * Constructor method for SalesPricesInquiry
     * @uses SalesPricesInquiry::setEffectiveAsOf()
     * @uses SalesPricesInquiry::setInventoryID()
     * @uses SalesPricesInquiry::setItemClassID()
     * @uses SalesPricesInquiry::setPriceClass()
     * @uses SalesPricesInquiry::setPriceCode()
     * @uses SalesPricesInquiry::setPriceManager()
     * @uses SalesPricesInquiry::setPriceManagerIsMe()
     * @uses SalesPricesInquiry::setPriceType()
     * @uses SalesPricesInquiry::setPriceWorkgroup()
     * @uses SalesPricesInquiry::setPriceWorkgroupIsMine()
     * @uses SalesPricesInquiry::setSalesPriceDetails()
     * @param \AcumaticaConfig\StructType\DateTimeValue $effectiveAsOf
     * @param \AcumaticaConfig\StructType\StringValue $inventoryID
     * @param \AcumaticaConfig\StructType\StringValue $itemClassID
     * @param \AcumaticaConfig\StructType\StringValue $priceClass
     * @param \AcumaticaConfig\StructType\StringValue $priceCode
     * @param \AcumaticaConfig\StructType\StringValue $priceManager
     * @param \AcumaticaConfig\StructType\BooleanValue $priceManagerIsMe
     * @param \AcumaticaConfig\StructType\StringValue $priceType
     * @param \AcumaticaConfig\StructType\StringValue $priceWorkgroup
     * @param \AcumaticaConfig\StructType\BooleanValue $priceWorkgroupIsMine
     * @param \AcumaticaConfig\StructType\SalesPriceDetails $salesPriceDetails
     */
    public function __construct(\AcumaticaConfig\StructType\DateTimeValue $effectiveAsOf = null, \AcumaticaConfig\StructType\StringValue $inventoryID = null, \AcumaticaConfig\StructType\StringValue $itemClassID = null, \AcumaticaConfig\StructType\StringValue $priceClass = null, \AcumaticaConfig\StructType\StringValue $priceCode = null, \AcumaticaConfig\StructType\StringValue $priceManager = null, \AcumaticaConfig\StructType\BooleanValue $priceManagerIsMe = null, \AcumaticaConfig\StructType\StringValue $priceType = null, \AcumaticaConfig\StructType\StringValue $priceWorkgroup = null, \AcumaticaConfig\StructType\BooleanValue $priceWorkgroupIsMine = null, \AcumaticaConfig\StructType\SalesPriceDetails $salesPriceDetails = null)
    {
        $this
            ->setEffectiveAsOf($effectiveAsOf)
            ->setInventoryID($inventoryID)
            ->setItemClassID($itemClassID)
            ->setPriceClass($priceClass)
            ->setPriceCode($priceCode)
            ->setPriceManager($priceManager)
            ->setPriceManagerIsMe($priceManagerIsMe)
            ->setPriceType($priceType)
            ->setPriceWorkgroup($priceWorkgroup)
            ->setPriceWorkgroupIsMine($priceWorkgroupIsMine)
            ->setSalesPriceDetails($salesPriceDetails);
    }
    /**
     * Get EffectiveAsOf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getEffectiveAsOf()
    {
        return isset($this->EffectiveAsOf) ? $this->EffectiveAsOf : null;
    }
    /**
     * Set EffectiveAsOf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $effectiveAsOf
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setEffectiveAsOf(\AcumaticaConfig\StructType\DateTimeValue $effectiveAsOf = null)
    {
        if (is_null($effectiveAsOf) || (is_array($effectiveAsOf) && empty($effectiveAsOf))) {
            unset($this->EffectiveAsOf);
        } else {
            $this->EffectiveAsOf = $effectiveAsOf;
        }
        return $this;
    }
    /**
     * Get InventoryID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getInventoryID()
    {
        return isset($this->InventoryID) ? $this->InventoryID : null;
    }
    /**
     * Set InventoryID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $inventoryID
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setInventoryID(\AcumaticaConfig\StructType\StringValue $inventoryID = null)
    {
        if (is_null($inventoryID) || (is_array($inventoryID) && empty($inventoryID))) {
            unset($this->InventoryID);
        } else {
            $this->InventoryID = $inventoryID;
        }
        return $this;
    }
    /**
     * Get ItemClassID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getItemClassID()
    {
        return isset($this->ItemClassID) ? $this->ItemClassID : null;
    }
    /**
     * Set ItemClassID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $itemClassID
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setItemClassID(\AcumaticaConfig\StructType\StringValue $itemClassID = null)
    {
        if (is_null($itemClassID) || (is_array($itemClassID) && empty($itemClassID))) {
            unset($this->ItemClassID);
        } else {
            $this->ItemClassID = $itemClassID;
        }
        return $this;
    }
    /**
     * Get PriceClass value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPriceClass()
    {
        return isset($this->PriceClass) ? $this->PriceClass : null;
    }
    /**
     * Set PriceClass value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $priceClass
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceClass(\AcumaticaConfig\StructType\StringValue $priceClass = null)
    {
        if (is_null($priceClass) || (is_array($priceClass) && empty($priceClass))) {
            unset($this->PriceClass);
        } else {
            $this->PriceClass = $priceClass;
        }
        return $this;
    }
    /**
     * Get PriceCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPriceCode()
    {
        return isset($this->PriceCode) ? $this->PriceCode : null;
    }
    /**
     * Set PriceCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $priceCode
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceCode(\AcumaticaConfig\StructType\StringValue $priceCode = null)
    {
        if (is_null($priceCode) || (is_array($priceCode) && empty($priceCode))) {
            unset($this->PriceCode);
        } else {
            $this->PriceCode = $priceCode;
        }
        return $this;
    }
    /**
     * Get PriceManager value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPriceManager()
    {
        return isset($this->PriceManager) ? $this->PriceManager : null;
    }
    /**
     * Set PriceManager value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $priceManager
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceManager(\AcumaticaConfig\StructType\StringValue $priceManager = null)
    {
        if (is_null($priceManager) || (is_array($priceManager) && empty($priceManager))) {
            unset($this->PriceManager);
        } else {
            $this->PriceManager = $priceManager;
        }
        return $this;
    }
    /**
     * Get PriceManagerIsMe value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getPriceManagerIsMe()
    {
        return isset($this->PriceManagerIsMe) ? $this->PriceManagerIsMe : null;
    }
    /**
     * Set PriceManagerIsMe value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $priceManagerIsMe
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceManagerIsMe(\AcumaticaConfig\StructType\BooleanValue $priceManagerIsMe = null)
    {
        if (is_null($priceManagerIsMe) || (is_array($priceManagerIsMe) && empty($priceManagerIsMe))) {
            unset($this->PriceManagerIsMe);
        } else {
            $this->PriceManagerIsMe = $priceManagerIsMe;
        }
        return $this;
    }
    /**
     * Get PriceType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPriceType()
    {
        return isset($this->PriceType) ? $this->PriceType : null;
    }
    /**
     * Set PriceType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $priceType
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceType(\AcumaticaConfig\StructType\StringValue $priceType = null)
    {
        if (is_null($priceType) || (is_array($priceType) && empty($priceType))) {
            unset($this->PriceType);
        } else {
            $this->PriceType = $priceType;
        }
        return $this;
    }
    /**
     * Get PriceWorkgroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getPriceWorkgroup()
    {
        return isset($this->PriceWorkgroup) ? $this->PriceWorkgroup : null;
    }
    /**
     * Set PriceWorkgroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $priceWorkgroup
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceWorkgroup(\AcumaticaConfig\StructType\StringValue $priceWorkgroup = null)
    {
        if (is_null($priceWorkgroup) || (is_array($priceWorkgroup) && empty($priceWorkgroup))) {
            unset($this->PriceWorkgroup);
        } else {
            $this->PriceWorkgroup = $priceWorkgroup;
        }
        return $this;
    }
    /**
     * Get PriceWorkgroupIsMine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getPriceWorkgroupIsMine()
    {
        return isset($this->PriceWorkgroupIsMine) ? $this->PriceWorkgroupIsMine : null;
    }
    /**
     * Set PriceWorkgroupIsMine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $priceWorkgroupIsMine
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setPriceWorkgroupIsMine(\AcumaticaConfig\StructType\BooleanValue $priceWorkgroupIsMine = null)
    {
        if (is_null($priceWorkgroupIsMine) || (is_array($priceWorkgroupIsMine) && empty($priceWorkgroupIsMine))) {
            unset($this->PriceWorkgroupIsMine);
        } else {
            $this->PriceWorkgroupIsMine = $priceWorkgroupIsMine;
        }
        return $this;
    }
    /**
     * Get SalesPriceDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\SalesPriceDetails|null
     */
    public function getSalesPriceDetails()
    {
        return isset($this->SalesPriceDetails) ? $this->SalesPriceDetails : null;
    }
    /**
     * Set SalesPriceDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\SalesPriceDetails $salesPriceDetails
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public function setSalesPriceDetails(\AcumaticaConfig\StructType\SalesPriceDetails $salesPriceDetails = null)
    {
        if (is_null($salesPriceDetails) || (is_array($salesPriceDetails) && empty($salesPriceDetails))) {
            unset($this->SalesPriceDetails);
        } else {
            $this->SalesPriceDetails = $salesPriceDetails;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\SalesPricesInquiry
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
