<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SegmentConfiguration StructType
 * @subpackage Structs
 */
class SegmentConfiguration extends Entity
{
    /**
     * The AllowAddingNewValuesOntheFly
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $AllowAddingNewValuesOntheFly;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The Length
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ShortValue
     */
    public $Length;
    /**
     * The LookupMode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $LookupMode;
    /**
     * The MaxLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $MaxLength;
    /**
     * The NumberingID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $NumberingID;
    /**
     * The Parent
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Parent;
    /**
     * The SegmentedKeyID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $SegmentedKeyID;
    /**
     * The Segments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\ShortValue
     */
    public $Segments;
    /**
     * The SegmentValues
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\SegmentValues
     */
    public $SegmentValues;
    /**
     * The SpecificModule
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $SpecificModule;
    /**
     * Constructor method for SegmentConfiguration
     * @uses SegmentConfiguration::setAllowAddingNewValuesOntheFly()
     * @uses SegmentConfiguration::setDescription()
     * @uses SegmentConfiguration::setLength()
     * @uses SegmentConfiguration::setLookupMode()
     * @uses SegmentConfiguration::setMaxLength()
     * @uses SegmentConfiguration::setNumberingID()
     * @uses SegmentConfiguration::setParent()
     * @uses SegmentConfiguration::setSegmentedKeyID()
     * @uses SegmentConfiguration::setSegments()
     * @uses SegmentConfiguration::setSegmentValues()
     * @uses SegmentConfiguration::setSpecificModule()
     * @param \AcumaticaConfig\StructType\BooleanValue $allowAddingNewValuesOntheFly
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\ShortValue $length
     * @param \AcumaticaConfig\StructType\StringValue $lookupMode
     * @param \AcumaticaConfig\StructType\IntValue $maxLength
     * @param \AcumaticaConfig\StructType\StringValue $numberingID
     * @param \AcumaticaConfig\StructType\StringValue $parent
     * @param \AcumaticaConfig\StructType\StringValue $segmentedKeyID
     * @param \AcumaticaConfig\StructType\ShortValue $segments
     * @param \AcumaticaConfig\StructType\SegmentValues $segmentValues
     * @param \AcumaticaConfig\StructType\StringValue $specificModule
     */
    public function __construct(\AcumaticaConfig\StructType\BooleanValue $allowAddingNewValuesOntheFly = null, \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\ShortValue $length = null, \AcumaticaConfig\StructType\StringValue $lookupMode = null, \AcumaticaConfig\StructType\IntValue $maxLength = null, \AcumaticaConfig\StructType\StringValue $numberingID = null, \AcumaticaConfig\StructType\StringValue $parent = null, \AcumaticaConfig\StructType\StringValue $segmentedKeyID = null, \AcumaticaConfig\StructType\ShortValue $segments = null, \AcumaticaConfig\StructType\SegmentValues $segmentValues = null, \AcumaticaConfig\StructType\StringValue $specificModule = null)
    {
        $this
            ->setAllowAddingNewValuesOntheFly($allowAddingNewValuesOntheFly)
            ->setDescription($description)
            ->setLength($length)
            ->setLookupMode($lookupMode)
            ->setMaxLength($maxLength)
            ->setNumberingID($numberingID)
            ->setParent($parent)
            ->setSegmentedKeyID($segmentedKeyID)
            ->setSegments($segments)
            ->setSegmentValues($segmentValues)
            ->setSpecificModule($specificModule);
    }
    /**
     * Get AllowAddingNewValuesOntheFly value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getAllowAddingNewValuesOntheFly()
    {
        return isset($this->AllowAddingNewValuesOntheFly) ? $this->AllowAddingNewValuesOntheFly : null;
    }
    /**
     * Set AllowAddingNewValuesOntheFly value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $allowAddingNewValuesOntheFly
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setAllowAddingNewValuesOntheFly(\AcumaticaConfig\StructType\BooleanValue $allowAddingNewValuesOntheFly = null)
    {
        if (is_null($allowAddingNewValuesOntheFly) || (is_array($allowAddingNewValuesOntheFly) && empty($allowAddingNewValuesOntheFly))) {
            unset($this->AllowAddingNewValuesOntheFly);
        } else {
            $this->AllowAddingNewValuesOntheFly = $allowAddingNewValuesOntheFly;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Length value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ShortValue|null
     */
    public function getLength()
    {
        return isset($this->Length) ? $this->Length : null;
    }
    /**
     * Set Length value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\ShortValue $length
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setLength(\AcumaticaConfig\StructType\ShortValue $length = null)
    {
        if (is_null($length) || (is_array($length) && empty($length))) {
            unset($this->Length);
        } else {
            $this->Length = $length;
        }
        return $this;
    }
    /**
     * Get LookupMode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getLookupMode()
    {
        return isset($this->LookupMode) ? $this->LookupMode : null;
    }
    /**
     * Set LookupMode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $lookupMode
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setLookupMode(\AcumaticaConfig\StructType\StringValue $lookupMode = null)
    {
        if (is_null($lookupMode) || (is_array($lookupMode) && empty($lookupMode))) {
            unset($this->LookupMode);
        } else {
            $this->LookupMode = $lookupMode;
        }
        return $this;
    }
    /**
     * Get MaxLength value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getMaxLength()
    {
        return isset($this->MaxLength) ? $this->MaxLength : null;
    }
    /**
     * Set MaxLength value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $maxLength
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setMaxLength(\AcumaticaConfig\StructType\IntValue $maxLength = null)
    {
        if (is_null($maxLength) || (is_array($maxLength) && empty($maxLength))) {
            unset($this->MaxLength);
        } else {
            $this->MaxLength = $maxLength;
        }
        return $this;
    }
    /**
     * Get NumberingID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getNumberingID()
    {
        return isset($this->NumberingID) ? $this->NumberingID : null;
    }
    /**
     * Set NumberingID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $numberingID
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setNumberingID(\AcumaticaConfig\StructType\StringValue $numberingID = null)
    {
        if (is_null($numberingID) || (is_array($numberingID) && empty($numberingID))) {
            unset($this->NumberingID);
        } else {
            $this->NumberingID = $numberingID;
        }
        return $this;
    }
    /**
     * Get Parent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getParent()
    {
        return isset($this->Parent) ? $this->Parent : null;
    }
    /**
     * Set Parent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $parent
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setParent(\AcumaticaConfig\StructType\StringValue $parent = null)
    {
        if (is_null($parent) || (is_array($parent) && empty($parent))) {
            unset($this->Parent);
        } else {
            $this->Parent = $parent;
        }
        return $this;
    }
    /**
     * Get SegmentedKeyID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getSegmentedKeyID()
    {
        return isset($this->SegmentedKeyID) ? $this->SegmentedKeyID : null;
    }
    /**
     * Set SegmentedKeyID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $segmentedKeyID
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setSegmentedKeyID(\AcumaticaConfig\StructType\StringValue $segmentedKeyID = null)
    {
        if (is_null($segmentedKeyID) || (is_array($segmentedKeyID) && empty($segmentedKeyID))) {
            unset($this->SegmentedKeyID);
        } else {
            $this->SegmentedKeyID = $segmentedKeyID;
        }
        return $this;
    }
    /**
     * Get Segments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\ShortValue|null
     */
    public function getSegments()
    {
        return isset($this->Segments) ? $this->Segments : null;
    }
    /**
     * Set Segments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\ShortValue $segments
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setSegments(\AcumaticaConfig\StructType\ShortValue $segments = null)
    {
        if (is_null($segments) || (is_array($segments) && empty($segments))) {
            unset($this->Segments);
        } else {
            $this->Segments = $segments;
        }
        return $this;
    }
    /**
     * Get SegmentValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\SegmentValues|null
     */
    public function getSegmentValues()
    {
        return isset($this->SegmentValues) ? $this->SegmentValues : null;
    }
    /**
     * Set SegmentValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\SegmentValues $segmentValues
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setSegmentValues(\AcumaticaConfig\StructType\SegmentValues $segmentValues = null)
    {
        if (is_null($segmentValues) || (is_array($segmentValues) && empty($segmentValues))) {
            unset($this->SegmentValues);
        } else {
            $this->SegmentValues = $segmentValues;
        }
        return $this;
    }
    /**
     * Get SpecificModule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getSpecificModule()
    {
        return isset($this->SpecificModule) ? $this->SpecificModule : null;
    }
    /**
     * Set SpecificModule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $specificModule
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public function setSpecificModule(\AcumaticaConfig\StructType\StringValue $specificModule = null)
    {
        if (is_null($specificModule) || (is_array($specificModule) && empty($specificModule))) {
            unset($this->SpecificModule);
        } else {
            $this->SpecificModule = $specificModule;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\SegmentConfiguration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
