<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Segments StructType
 * @subpackage Structs
 */
class Segments extends AbstractStructBase
{
    /**
     * The LotSerialClassSegment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\LotSerialClassSegment[]
     */
    public $LotSerialClassSegment;
    /**
     * Constructor method for Segments
     * @uses Segments::setLotSerialClassSegment()
     * @param \AcumaticaConfig\StructType\LotSerialClassSegment[] $lotSerialClassSegment
     */
    public function __construct(array $lotSerialClassSegment = array())
    {
        $this
            ->setLotSerialClassSegment($lotSerialClassSegment);
    }
    /**
     * Get LotSerialClassSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\LotSerialClassSegment[]|null
     */
    public function getLotSerialClassSegment()
    {
        return isset($this->LotSerialClassSegment) ? $this->LotSerialClassSegment : null;
    }
    /**
     * Set LotSerialClassSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\LotSerialClassSegment[] $lotSerialClassSegment
     * @return \AcumaticaConfig\StructType\Segments
     */
    public function setLotSerialClassSegment(array $lotSerialClassSegment = array())
    {
        foreach ($lotSerialClassSegment as $segmentsLotSerialClassSegmentItem) {
            // validation for constraint: itemType
            if (!$segmentsLotSerialClassSegmentItem instanceof \AcumaticaConfig\StructType\LotSerialClassSegment) {
                throw new \InvalidArgumentException(sprintf('The LotSerialClassSegment property can only contain items of \AcumaticaConfig\StructType\LotSerialClassSegment, "%s" given', is_object($segmentsLotSerialClassSegmentItem) ? get_class($segmentsLotSerialClassSegmentItem) : gettype($segmentsLotSerialClassSegmentItem)), __LINE__);
            }
        }
        if (is_null($lotSerialClassSegment) || (is_array($lotSerialClassSegment) && empty($lotSerialClassSegment))) {
            unset($this->LotSerialClassSegment);
        } else {
            $this->LotSerialClassSegment = $lotSerialClassSegment;
        }
        return $this;
    }
    /**
     * Add item to LotSerialClassSegment value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\LotSerialClassSegment $item
     * @return \AcumaticaConfig\StructType\Segments
     */
    public function addToLotSerialClassSegment(\AcumaticaConfig\StructType\LotSerialClassSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\LotSerialClassSegment) {
            throw new \InvalidArgumentException(sprintf('The LotSerialClassSegment property can only contain items of \AcumaticaConfig\StructType\LotSerialClassSegment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LotSerialClassSegment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\Segments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
