<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipVia StructType
 * @subpackage Structs
 */
class ShipVia extends Entity
{
    /**
     * The CalculationMethod
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $CalculationMethod;
    /**
     * The Calendar
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Calendar;
    /**
     * The CarrierID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $CarrierID;
    /**
     * The CommonCarrier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\BooleanValue
     */
    public $CommonCarrier;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The FreightExpenseAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $FreightExpenseAccount;
    /**
     * The FreightExpenseSubaccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $FreightExpenseSubaccount;
    /**
     * The FreightRates
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\FreightRates
     */
    public $FreightRates;
    /**
     * The FreightSalesAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $FreightSalesAccount;
    /**
     * The FreightSalesSubaccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $FreightSalesSubaccount;
    /**
     * The Packages
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\Packages
     */
    public $Packages;
    /**
     * The TaxCategory
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $TaxCategory;
    /**
     * Constructor method for ShipVia
     * @uses ShipVia::setCalculationMethod()
     * @uses ShipVia::setCalendar()
     * @uses ShipVia::setCarrierID()
     * @uses ShipVia::setCommonCarrier()
     * @uses ShipVia::setDescription()
     * @uses ShipVia::setFreightExpenseAccount()
     * @uses ShipVia::setFreightExpenseSubaccount()
     * @uses ShipVia::setFreightRates()
     * @uses ShipVia::setFreightSalesAccount()
     * @uses ShipVia::setFreightSalesSubaccount()
     * @uses ShipVia::setPackages()
     * @uses ShipVia::setTaxCategory()
     * @param \AcumaticaConfig\StructType\StringValue $calculationMethod
     * @param \AcumaticaConfig\StructType\StringValue $calendar
     * @param \AcumaticaConfig\StructType\StringValue $carrierID
     * @param \AcumaticaConfig\StructType\BooleanValue $commonCarrier
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\StringValue $freightExpenseAccount
     * @param \AcumaticaConfig\StructType\StringValue $freightExpenseSubaccount
     * @param \AcumaticaConfig\StructType\FreightRates $freightRates
     * @param \AcumaticaConfig\StructType\StringValue $freightSalesAccount
     * @param \AcumaticaConfig\StructType\StringValue $freightSalesSubaccount
     * @param \AcumaticaConfig\StructType\Packages $packages
     * @param \AcumaticaConfig\StructType\StringValue $taxCategory
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $calculationMethod = null, \AcumaticaConfig\StructType\StringValue $calendar = null, \AcumaticaConfig\StructType\StringValue $carrierID = null, \AcumaticaConfig\StructType\BooleanValue $commonCarrier = null, \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\StringValue $freightExpenseAccount = null, \AcumaticaConfig\StructType\StringValue $freightExpenseSubaccount = null, \AcumaticaConfig\StructType\FreightRates $freightRates = null, \AcumaticaConfig\StructType\StringValue $freightSalesAccount = null, \AcumaticaConfig\StructType\StringValue $freightSalesSubaccount = null, \AcumaticaConfig\StructType\Packages $packages = null, \AcumaticaConfig\StructType\StringValue $taxCategory = null)
    {
        $this
            ->setCalculationMethod($calculationMethod)
            ->setCalendar($calendar)
            ->setCarrierID($carrierID)
            ->setCommonCarrier($commonCarrier)
            ->setDescription($description)
            ->setFreightExpenseAccount($freightExpenseAccount)
            ->setFreightExpenseSubaccount($freightExpenseSubaccount)
            ->setFreightRates($freightRates)
            ->setFreightSalesAccount($freightSalesAccount)
            ->setFreightSalesSubaccount($freightSalesSubaccount)
            ->setPackages($packages)
            ->setTaxCategory($taxCategory);
    }
    /**
     * Get CalculationMethod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getCalculationMethod()
    {
        return isset($this->CalculationMethod) ? $this->CalculationMethod : null;
    }
    /**
     * Set CalculationMethod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $calculationMethod
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setCalculationMethod(\AcumaticaConfig\StructType\StringValue $calculationMethod = null)
    {
        if (is_null($calculationMethod) || (is_array($calculationMethod) && empty($calculationMethod))) {
            unset($this->CalculationMethod);
        } else {
            $this->CalculationMethod = $calculationMethod;
        }
        return $this;
    }
    /**
     * Get Calendar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getCalendar()
    {
        return isset($this->Calendar) ? $this->Calendar : null;
    }
    /**
     * Set Calendar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $calendar
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setCalendar(\AcumaticaConfig\StructType\StringValue $calendar = null)
    {
        if (is_null($calendar) || (is_array($calendar) && empty($calendar))) {
            unset($this->Calendar);
        } else {
            $this->Calendar = $calendar;
        }
        return $this;
    }
    /**
     * Get CarrierID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getCarrierID()
    {
        return isset($this->CarrierID) ? $this->CarrierID : null;
    }
    /**
     * Set CarrierID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $carrierID
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setCarrierID(\AcumaticaConfig\StructType\StringValue $carrierID = null)
    {
        if (is_null($carrierID) || (is_array($carrierID) && empty($carrierID))) {
            unset($this->CarrierID);
        } else {
            $this->CarrierID = $carrierID;
        }
        return $this;
    }
    /**
     * Get CommonCarrier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\BooleanValue|null
     */
    public function getCommonCarrier()
    {
        return isset($this->CommonCarrier) ? $this->CommonCarrier : null;
    }
    /**
     * Set CommonCarrier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\BooleanValue $commonCarrier
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setCommonCarrier(\AcumaticaConfig\StructType\BooleanValue $commonCarrier = null)
    {
        if (is_null($commonCarrier) || (is_array($commonCarrier) && empty($commonCarrier))) {
            unset($this->CommonCarrier);
        } else {
            $this->CommonCarrier = $commonCarrier;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get FreightExpenseAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getFreightExpenseAccount()
    {
        return isset($this->FreightExpenseAccount) ? $this->FreightExpenseAccount : null;
    }
    /**
     * Set FreightExpenseAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $freightExpenseAccount
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setFreightExpenseAccount(\AcumaticaConfig\StructType\StringValue $freightExpenseAccount = null)
    {
        if (is_null($freightExpenseAccount) || (is_array($freightExpenseAccount) && empty($freightExpenseAccount))) {
            unset($this->FreightExpenseAccount);
        } else {
            $this->FreightExpenseAccount = $freightExpenseAccount;
        }
        return $this;
    }
    /**
     * Get FreightExpenseSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getFreightExpenseSubaccount()
    {
        return isset($this->FreightExpenseSubaccount) ? $this->FreightExpenseSubaccount : null;
    }
    /**
     * Set FreightExpenseSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $freightExpenseSubaccount
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setFreightExpenseSubaccount(\AcumaticaConfig\StructType\StringValue $freightExpenseSubaccount = null)
    {
        if (is_null($freightExpenseSubaccount) || (is_array($freightExpenseSubaccount) && empty($freightExpenseSubaccount))) {
            unset($this->FreightExpenseSubaccount);
        } else {
            $this->FreightExpenseSubaccount = $freightExpenseSubaccount;
        }
        return $this;
    }
    /**
     * Get FreightRates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\FreightRates|null
     */
    public function getFreightRates()
    {
        return isset($this->FreightRates) ? $this->FreightRates : null;
    }
    /**
     * Set FreightRates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\FreightRates $freightRates
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setFreightRates(\AcumaticaConfig\StructType\FreightRates $freightRates = null)
    {
        if (is_null($freightRates) || (is_array($freightRates) && empty($freightRates))) {
            unset($this->FreightRates);
        } else {
            $this->FreightRates = $freightRates;
        }
        return $this;
    }
    /**
     * Get FreightSalesAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getFreightSalesAccount()
    {
        return isset($this->FreightSalesAccount) ? $this->FreightSalesAccount : null;
    }
    /**
     * Set FreightSalesAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $freightSalesAccount
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setFreightSalesAccount(\AcumaticaConfig\StructType\StringValue $freightSalesAccount = null)
    {
        if (is_null($freightSalesAccount) || (is_array($freightSalesAccount) && empty($freightSalesAccount))) {
            unset($this->FreightSalesAccount);
        } else {
            $this->FreightSalesAccount = $freightSalesAccount;
        }
        return $this;
    }
    /**
     * Get FreightSalesSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getFreightSalesSubaccount()
    {
        return isset($this->FreightSalesSubaccount) ? $this->FreightSalesSubaccount : null;
    }
    /**
     * Set FreightSalesSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $freightSalesSubaccount
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setFreightSalesSubaccount(\AcumaticaConfig\StructType\StringValue $freightSalesSubaccount = null)
    {
        if (is_null($freightSalesSubaccount) || (is_array($freightSalesSubaccount) && empty($freightSalesSubaccount))) {
            unset($this->FreightSalesSubaccount);
        } else {
            $this->FreightSalesSubaccount = $freightSalesSubaccount;
        }
        return $this;
    }
    /**
     * Get Packages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\Packages|null
     */
    public function getPackages()
    {
        return isset($this->Packages) ? $this->Packages : null;
    }
    /**
     * Set Packages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\Packages $packages
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setPackages(\AcumaticaConfig\StructType\Packages $packages = null)
    {
        if (is_null($packages) || (is_array($packages) && empty($packages))) {
            unset($this->Packages);
        } else {
            $this->Packages = $packages;
        }
        return $this;
    }
    /**
     * Get TaxCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTaxCategory()
    {
        return isset($this->TaxCategory) ? $this->TaxCategory : null;
    }
    /**
     * Set TaxCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $taxCategory
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public function setTaxCategory(\AcumaticaConfig\StructType\StringValue $taxCategory = null)
    {
        if (is_null($taxCategory) || (is_array($taxCategory) && empty($taxCategory))) {
            unset($this->TaxCategory);
        } else {
            $this->TaxCategory = $taxCategory;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ShipVia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
