<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipViaFreightRate StructType
 * @subpackage Structs
 */
class ShipViaFreightRate extends Entity
{
    /**
     * The LineNbr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $LineNbr;
    /**
     * The Rate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $Rate;
    /**
     * The Volume
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $Volume;
    /**
     * The Weight
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $Weight;
    /**
     * The ZoneID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $ZoneID;
    /**
     * Constructor method for ShipViaFreightRate
     * @uses ShipViaFreightRate::setLineNbr()
     * @uses ShipViaFreightRate::setRate()
     * @uses ShipViaFreightRate::setVolume()
     * @uses ShipViaFreightRate::setWeight()
     * @uses ShipViaFreightRate::setZoneID()
     * @param \AcumaticaConfig\StructType\IntValue $lineNbr
     * @param \AcumaticaConfig\StructType\DecimalValue $rate
     * @param \AcumaticaConfig\StructType\DecimalValue $volume
     * @param \AcumaticaConfig\StructType\DecimalValue $weight
     * @param \AcumaticaConfig\StructType\StringValue $zoneID
     */
    public function __construct(\AcumaticaConfig\StructType\IntValue $lineNbr = null, \AcumaticaConfig\StructType\DecimalValue $rate = null, \AcumaticaConfig\StructType\DecimalValue $volume = null, \AcumaticaConfig\StructType\DecimalValue $weight = null, \AcumaticaConfig\StructType\StringValue $zoneID = null)
    {
        $this
            ->setLineNbr($lineNbr)
            ->setRate($rate)
            ->setVolume($volume)
            ->setWeight($weight)
            ->setZoneID($zoneID);
    }
    /**
     * Get LineNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getLineNbr()
    {
        return isset($this->LineNbr) ? $this->LineNbr : null;
    }
    /**
     * Set LineNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $lineNbr
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public function setLineNbr(\AcumaticaConfig\StructType\IntValue $lineNbr = null)
    {
        if (is_null($lineNbr) || (is_array($lineNbr) && empty($lineNbr))) {
            unset($this->LineNbr);
        } else {
            $this->LineNbr = $lineNbr;
        }
        return $this;
    }
    /**
     * Get Rate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getRate()
    {
        return isset($this->Rate) ? $this->Rate : null;
    }
    /**
     * Set Rate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $rate
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public function setRate(\AcumaticaConfig\StructType\DecimalValue $rate = null)
    {
        if (is_null($rate) || (is_array($rate) && empty($rate))) {
            unset($this->Rate);
        } else {
            $this->Rate = $rate;
        }
        return $this;
    }
    /**
     * Get Volume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getVolume()
    {
        return isset($this->Volume) ? $this->Volume : null;
    }
    /**
     * Set Volume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $volume
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public function setVolume(\AcumaticaConfig\StructType\DecimalValue $volume = null)
    {
        if (is_null($volume) || (is_array($volume) && empty($volume))) {
            unset($this->Volume);
        } else {
            $this->Volume = $volume;
        }
        return $this;
    }
    /**
     * Get Weight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getWeight()
    {
        return isset($this->Weight) ? $this->Weight : null;
    }
    /**
     * Set Weight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $weight
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public function setWeight(\AcumaticaConfig\StructType\DecimalValue $weight = null)
    {
        if (is_null($weight) || (is_array($weight) && empty($weight))) {
            unset($this->Weight);
        } else {
            $this->Weight = $weight;
        }
        return $this;
    }
    /**
     * Get ZoneID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getZoneID()
    {
        return isset($this->ZoneID) ? $this->ZoneID : null;
    }
    /**
     * Set ZoneID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $zoneID
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public function setZoneID(\AcumaticaConfig\StructType\StringValue $zoneID = null)
    {
        if (is_null($zoneID) || (is_array($zoneID) && empty($zoneID))) {
            unset($this->ZoneID);
        } else {
            $this->ZoneID = $zoneID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ShipViaFreightRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
