<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingTermDetail StructType
 * @subpackage Structs
 */
class ShippingTermDetail extends Entity
{
    /**
     * The BreakAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $BreakAmount;
    /**
     * The FreightCost
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $FreightCost;
    /**
     * The InvoiceAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $InvoiceAmount;
    /**
     * The LineHandling
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $LineHandling;
    /**
     * The LineNbr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\IntValue
     */
    public $LineNbr;
    /**
     * The ShippingandHandling
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DecimalValue
     */
    public $ShippingandHandling;
    /**
     * Constructor method for ShippingTermDetail
     * @uses ShippingTermDetail::setBreakAmount()
     * @uses ShippingTermDetail::setFreightCost()
     * @uses ShippingTermDetail::setInvoiceAmount()
     * @uses ShippingTermDetail::setLineHandling()
     * @uses ShippingTermDetail::setLineNbr()
     * @uses ShippingTermDetail::setShippingandHandling()
     * @param \AcumaticaConfig\StructType\DecimalValue $breakAmount
     * @param \AcumaticaConfig\StructType\DecimalValue $freightCost
     * @param \AcumaticaConfig\StructType\DecimalValue $invoiceAmount
     * @param \AcumaticaConfig\StructType\DecimalValue $lineHandling
     * @param \AcumaticaConfig\StructType\IntValue $lineNbr
     * @param \AcumaticaConfig\StructType\DecimalValue $shippingandHandling
     */
    public function __construct(\AcumaticaConfig\StructType\DecimalValue $breakAmount = null, \AcumaticaConfig\StructType\DecimalValue $freightCost = null, \AcumaticaConfig\StructType\DecimalValue $invoiceAmount = null, \AcumaticaConfig\StructType\DecimalValue $lineHandling = null, \AcumaticaConfig\StructType\IntValue $lineNbr = null, \AcumaticaConfig\StructType\DecimalValue $shippingandHandling = null)
    {
        $this
            ->setBreakAmount($breakAmount)
            ->setFreightCost($freightCost)
            ->setInvoiceAmount($invoiceAmount)
            ->setLineHandling($lineHandling)
            ->setLineNbr($lineNbr)
            ->setShippingandHandling($shippingandHandling);
    }
    /**
     * Get BreakAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getBreakAmount()
    {
        return isset($this->BreakAmount) ? $this->BreakAmount : null;
    }
    /**
     * Set BreakAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $breakAmount
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setBreakAmount(\AcumaticaConfig\StructType\DecimalValue $breakAmount = null)
    {
        if (is_null($breakAmount) || (is_array($breakAmount) && empty($breakAmount))) {
            unset($this->BreakAmount);
        } else {
            $this->BreakAmount = $breakAmount;
        }
        return $this;
    }
    /**
     * Get FreightCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getFreightCost()
    {
        return isset($this->FreightCost) ? $this->FreightCost : null;
    }
    /**
     * Set FreightCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $freightCost
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setFreightCost(\AcumaticaConfig\StructType\DecimalValue $freightCost = null)
    {
        if (is_null($freightCost) || (is_array($freightCost) && empty($freightCost))) {
            unset($this->FreightCost);
        } else {
            $this->FreightCost = $freightCost;
        }
        return $this;
    }
    /**
     * Get InvoiceAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getInvoiceAmount()
    {
        return isset($this->InvoiceAmount) ? $this->InvoiceAmount : null;
    }
    /**
     * Set InvoiceAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $invoiceAmount
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setInvoiceAmount(\AcumaticaConfig\StructType\DecimalValue $invoiceAmount = null)
    {
        if (is_null($invoiceAmount) || (is_array($invoiceAmount) && empty($invoiceAmount))) {
            unset($this->InvoiceAmount);
        } else {
            $this->InvoiceAmount = $invoiceAmount;
        }
        return $this;
    }
    /**
     * Get LineHandling value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getLineHandling()
    {
        return isset($this->LineHandling) ? $this->LineHandling : null;
    }
    /**
     * Set LineHandling value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $lineHandling
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setLineHandling(\AcumaticaConfig\StructType\DecimalValue $lineHandling = null)
    {
        if (is_null($lineHandling) || (is_array($lineHandling) && empty($lineHandling))) {
            unset($this->LineHandling);
        } else {
            $this->LineHandling = $lineHandling;
        }
        return $this;
    }
    /**
     * Get LineNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\IntValue|null
     */
    public function getLineNbr()
    {
        return isset($this->LineNbr) ? $this->LineNbr : null;
    }
    /**
     * Set LineNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\IntValue $lineNbr
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setLineNbr(\AcumaticaConfig\StructType\IntValue $lineNbr = null)
    {
        if (is_null($lineNbr) || (is_array($lineNbr) && empty($lineNbr))) {
            unset($this->LineNbr);
        } else {
            $this->LineNbr = $lineNbr;
        }
        return $this;
    }
    /**
     * Get ShippingandHandling value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DecimalValue|null
     */
    public function getShippingandHandling()
    {
        return isset($this->ShippingandHandling) ? $this->ShippingandHandling : null;
    }
    /**
     * Set ShippingandHandling value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DecimalValue $shippingandHandling
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public function setShippingandHandling(\AcumaticaConfig\StructType\DecimalValue $shippingandHandling = null)
    {
        if (is_null($shippingandHandling) || (is_array($shippingandHandling) && empty($shippingandHandling))) {
            unset($this->ShippingandHandling);
        } else {
            $this->ShippingandHandling = $shippingandHandling;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\ShippingTermDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
