<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TimeZone StructType
 * @subpackage Structs
 */
class TimeZone extends Entity
{
    /**
     * The Login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Login;
    /**
     * The ServerTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\DateTimeValue
     */
    public $ServerTime;
    /**
     * The TimeZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $TimeZone;
    /**
     * Constructor method for TimeZone
     * @uses TimeZone::setLogin()
     * @uses TimeZone::setServerTime()
     * @uses TimeZone::setTimeZone()
     * @param \AcumaticaConfig\StructType\StringValue $login
     * @param \AcumaticaConfig\StructType\DateTimeValue $serverTime
     * @param \AcumaticaConfig\StructType\StringValue $timeZone
     */
    public function __construct(\AcumaticaConfig\StructType\StringValue $login = null, \AcumaticaConfig\StructType\DateTimeValue $serverTime = null, \AcumaticaConfig\StructType\StringValue $timeZone = null)
    {
        $this
            ->setLogin($login)
            ->setServerTime($serverTime)
            ->setTimeZone($timeZone);
    }
    /**
     * Get Login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getLogin()
    {
        return isset($this->Login) ? $this->Login : null;
    }
    /**
     * Set Login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $login
     * @return \AcumaticaConfig\StructType\TimeZone
     */
    public function setLogin(\AcumaticaConfig\StructType\StringValue $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->Login);
        } else {
            $this->Login = $login;
        }
        return $this;
    }
    /**
     * Get ServerTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\DateTimeValue|null
     */
    public function getServerTime()
    {
        return isset($this->ServerTime) ? $this->ServerTime : null;
    }
    /**
     * Set ServerTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\DateTimeValue $serverTime
     * @return \AcumaticaConfig\StructType\TimeZone
     */
    public function setServerTime(\AcumaticaConfig\StructType\DateTimeValue $serverTime = null)
    {
        if (is_null($serverTime) || (is_array($serverTime) && empty($serverTime))) {
            unset($this->ServerTime);
        } else {
            $this->ServerTime = $serverTime;
        }
        return $this;
    }
    /**
     * Get TimeZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getTimeZone()
    {
        return isset($this->TimeZone) ? $this->TimeZone : null;
    }
    /**
     * Set TimeZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $timeZone
     * @return \AcumaticaConfig\StructType\TimeZone
     */
    public function setTimeZone(\AcumaticaConfig\StructType\StringValue $timeZone = null)
    {
        if (is_null($timeZone) || (is_array($timeZone) && empty($timeZone))) {
            unset($this->TimeZone);
        } else {
            $this->TimeZone = $timeZone;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\TimeZone
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
