<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpSells StructType
 * @subpackage Structs
 */
class UpSells extends Entity
{
    /**
     * The UpSells
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\UpSells[]
     */
    public $UpSells;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $Description;
    /**
     * The InventoryID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\StringValue
     */
    public $InventoryID;
    /**
     * Constructor method for UpSells
     * @uses UpSells::setUpSells()
     * @uses UpSells::setDescription()
     * @uses UpSells::setInventoryID()
     * @param \AcumaticaConfig\StructType\UpSells[] $upSells
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @param \AcumaticaConfig\StructType\StringValue $inventoryID
     */
    public function __construct(array $upSells = array(), \AcumaticaConfig\StructType\StringValue $description = null, \AcumaticaConfig\StructType\StringValue $inventoryID = null)
    {
        $this
            ->setUpSells($upSells)
            ->setDescription($description)
            ->setInventoryID($inventoryID);
    }
    /**
     * Get UpSells value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\UpSells[]|null
     */
    public function getUpSells()
    {
        return isset($this->UpSells) ? $this->UpSells : null;
    }
    /**
     * Set UpSells value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\UpSells[] $upSells
     * @return \AcumaticaConfig\StructType\UpSells
     */
    public function setUpSells(array $upSells = array())
    {
        foreach ($upSells as $upSellsUpSellsItem) {
            // validation for constraint: itemType
            if (!$upSellsUpSellsItem instanceof \AcumaticaConfig\StructType\UpSells) {
                throw new \InvalidArgumentException(sprintf('The UpSells property can only contain items of \AcumaticaConfig\StructType\UpSells, "%s" given', is_object($upSellsUpSellsItem) ? get_class($upSellsUpSellsItem) : gettype($upSellsUpSellsItem)), __LINE__);
            }
        }
        if (is_null($upSells) || (is_array($upSells) && empty($upSells))) {
            unset($this->UpSells);
        } else {
            $this->UpSells = $upSells;
        }
        return $this;
    }
    /**
     * Add item to UpSells value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\UpSells $item
     * @return \AcumaticaConfig\StructType\UpSells
     */
    public function addToUpSells(\AcumaticaConfig\StructType\UpSells $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\UpSells) {
            throw new \InvalidArgumentException(sprintf('The UpSells property can only contain items of \AcumaticaConfig\StructType\UpSells, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UpSells[] = $item;
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $description
     * @return \AcumaticaConfig\StructType\UpSells
     */
    public function setDescription(\AcumaticaConfig\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get InventoryID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\StringValue|null
     */
    public function getInventoryID()
    {
        return isset($this->InventoryID) ? $this->InventoryID : null;
    }
    /**
     * Set InventoryID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AcumaticaConfig\StructType\StringValue $inventoryID
     * @return \AcumaticaConfig\StructType\UpSells
     */
    public function setInventoryID(\AcumaticaConfig\StructType\StringValue $inventoryID = null)
    {
        if (is_null($inventoryID) || (is_array($inventoryID) && empty($inventoryID))) {
            unset($this->InventoryID);
        } else {
            $this->InventoryID = $inventoryID;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\UpSells
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
