<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorPriceDetails StructType
 * @subpackage Structs
 */
class VendorPriceDetails extends AbstractStructBase
{
    /**
     * The VendorPriceDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\VendorPriceDetail[]
     */
    public $VendorPriceDetail;
    /**
     * Constructor method for VendorPriceDetails
     * @uses VendorPriceDetails::setVendorPriceDetail()
     * @param \AcumaticaConfig\StructType\VendorPriceDetail[] $vendorPriceDetail
     */
    public function __construct(array $vendorPriceDetail = array())
    {
        $this
            ->setVendorPriceDetail($vendorPriceDetail);
    }
    /**
     * Get VendorPriceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\VendorPriceDetail[]|null
     */
    public function getVendorPriceDetail()
    {
        return isset($this->VendorPriceDetail) ? $this->VendorPriceDetail : null;
    }
    /**
     * Set VendorPriceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\VendorPriceDetail[] $vendorPriceDetail
     * @return \AcumaticaConfig\StructType\VendorPriceDetails
     */
    public function setVendorPriceDetail(array $vendorPriceDetail = array())
    {
        foreach ($vendorPriceDetail as $vendorPriceDetailsVendorPriceDetailItem) {
            // validation for constraint: itemType
            if (!$vendorPriceDetailsVendorPriceDetailItem instanceof \AcumaticaConfig\StructType\VendorPriceDetail) {
                throw new \InvalidArgumentException(sprintf('The VendorPriceDetail property can only contain items of \AcumaticaConfig\StructType\VendorPriceDetail, "%s" given', is_object($vendorPriceDetailsVendorPriceDetailItem) ? get_class($vendorPriceDetailsVendorPriceDetailItem) : gettype($vendorPriceDetailsVendorPriceDetailItem)), __LINE__);
            }
        }
        if (is_null($vendorPriceDetail) || (is_array($vendorPriceDetail) && empty($vendorPriceDetail))) {
            unset($this->VendorPriceDetail);
        } else {
            $this->VendorPriceDetail = $vendorPriceDetail;
        }
        return $this;
    }
    /**
     * Add item to VendorPriceDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\VendorPriceDetail $item
     * @return \AcumaticaConfig\StructType\VendorPriceDetails
     */
    public function addToVendorPriceDetail(\AcumaticaConfig\StructType\VendorPriceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\VendorPriceDetail) {
            throw new \InvalidArgumentException(sprintf('The VendorPriceDetail property can only contain items of \AcumaticaConfig\StructType\VendorPriceDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VendorPriceDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\VendorPriceDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
