<?php

namespace AcumaticaConfig\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorSalesPrices StructType
 * @subpackage Structs
 */
class VendorSalesPrices extends AbstractStructBase
{
    /**
     * The VendorPriceWorksheetDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \AcumaticaConfig\StructType\VendorPriceWorksheetDetail[]
     */
    public $VendorPriceWorksheetDetail;
    /**
     * Constructor method for VendorSalesPrices
     * @uses VendorSalesPrices::setVendorPriceWorksheetDetail()
     * @param \AcumaticaConfig\StructType\VendorPriceWorksheetDetail[] $vendorPriceWorksheetDetail
     */
    public function __construct(array $vendorPriceWorksheetDetail = array())
    {
        $this
            ->setVendorPriceWorksheetDetail($vendorPriceWorksheetDetail);
    }
    /**
     * Get VendorPriceWorksheetDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AcumaticaConfig\StructType\VendorPriceWorksheetDetail[]|null
     */
    public function getVendorPriceWorksheetDetail()
    {
        return isset($this->VendorPriceWorksheetDetail) ? $this->VendorPriceWorksheetDetail : null;
    }
    /**
     * Set VendorPriceWorksheetDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\VendorPriceWorksheetDetail[] $vendorPriceWorksheetDetail
     * @return \AcumaticaConfig\StructType\VendorSalesPrices
     */
    public function setVendorPriceWorksheetDetail(array $vendorPriceWorksheetDetail = array())
    {
        foreach ($vendorPriceWorksheetDetail as $vendorSalesPricesVendorPriceWorksheetDetailItem) {
            // validation for constraint: itemType
            if (!$vendorSalesPricesVendorPriceWorksheetDetailItem instanceof \AcumaticaConfig\StructType\VendorPriceWorksheetDetail) {
                throw new \InvalidArgumentException(sprintf('The VendorPriceWorksheetDetail property can only contain items of \AcumaticaConfig\StructType\VendorPriceWorksheetDetail, "%s" given', is_object($vendorSalesPricesVendorPriceWorksheetDetailItem) ? get_class($vendorSalesPricesVendorPriceWorksheetDetailItem) : gettype($vendorSalesPricesVendorPriceWorksheetDetailItem)), __LINE__);
            }
        }
        if (is_null($vendorPriceWorksheetDetail) || (is_array($vendorPriceWorksheetDetail) && empty($vendorPriceWorksheetDetail))) {
            unset($this->VendorPriceWorksheetDetail);
        } else {
            $this->VendorPriceWorksheetDetail = $vendorPriceWorksheetDetail;
        }
        return $this;
    }
    /**
     * Add item to VendorPriceWorksheetDetail value
     * @throws \InvalidArgumentException
     * @param \AcumaticaConfig\StructType\VendorPriceWorksheetDetail $item
     * @return \AcumaticaConfig\StructType\VendorSalesPrices
     */
    public function addToVendorPriceWorksheetDetail(\AcumaticaConfig\StructType\VendorPriceWorksheetDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AcumaticaConfig\StructType\VendorPriceWorksheetDetail) {
            throw new \InvalidArgumentException(sprintf('The VendorPriceWorksheetDetail property can only contain items of \AcumaticaConfig\StructType\VendorPriceWorksheetDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VendorPriceWorksheetDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AcumaticaConfig\StructType\VendorSalesPrices
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
